MODULE amg_multi_coloring
  implicit none
contains

  subroutine amg_coloring(LEVEL_NUM)

    USE data_structure_for_AMG

    integer(kind=kint),  intent(in)    :: LEVEL_NUM
    integer(kind=kint)                 :: N,NP,NPL,NPU

    real   (kind=kreal), dimension(:), pointer :: D

    real   (kind=kreal), dimension(:), pointer :: AU
    real   (kind=kreal), dimension(:), pointer :: AL

    integer(kind=kint ), dimension(:), pointer :: INU
    integer(kind=kint ), dimension(:), pointer :: IAU

    integer(kind=kint ), dimension(:), pointer :: INL
    integer(kind=kint ), dimension(:), pointer :: IAL

    integer(kind=kint ), dimension(:), pointer :: mul_col
    integer(kind=kint ), dimension(:), pointer :: col_ind
    integer(kind=kint ), dimension(:), pointer :: INML

!!$    !$        REAL   (kind=kreal), DIMENSION(:), pointer::  B
!!$    !$	REAL   (kind=kreal), DIMENSION(:), pointer :: VAL
!!$    !$      INTEGER(kind=kint), DIMENSION(:), pointer :: COL
!!$    !$      INTEGER(kind=kint), DIMENSION(:), pointer :: IND
!!$    !$      REAL   (kind=kreal), DIMENSION(:), pointer::  B_o

    integer(kind=kint ) :: nth_lev
    integer(kind=kint ) :: cnt, ierr

    DO nth_lev = 1 , LEVEL_NUM
       N = HIERARCHICAL_DATA(nth_lev) % N
       NP = HIERARCHICAL_DATA(nth_lev) % NP
!!$       !$		NPL= HIERARCHICAL_DATA(nth_lev) % NPL
!!$       !$		NPU= HIERARCHICAL_DATA(nth_lev) % NPU
       INU => HIERARCHICAL_DATA(nth_lev) % INU 
       INL => HIERARCHICAL_DATA(nth_lev) % INL 
       D => HIERARCHICAL_DATA(nth_lev) % D
       IAU => HIERARCHICAL_DATA(nth_lev) % IAU
       IAL => HIERARCHICAL_DATA(nth_lev) % IAL
       AU => HIERARCHICAL_DATA(nth_lev) % AU
       AL => HIERARCHICAL_DATA(nth_lev) % AL
!!$       !$		B => HIERARCHICAL_DATA(nth_lev) % B


       cnt = HIERARCHICAL_DATA(nth_lev) % color

       !C modified..
       !C allocate(HIERARCHICAL_DATA(nth_lev) % multi_color(NP))
       allocate(mul_col(NP))


!!$       allocate(HIERARCHICAL_DATA(nth_lev) % VAL_o(N+NPU+NPL),	&
!!$       		&	HIERARCHICAL_DATA(nth_lev) % COL_o(N+NPU+NPL),	&
!!$       		&	HIERARCHICAL_DATA(nth_lev) % IND_o(0:N),	&
!!$       		&	HIERARCHICAL_DATA(nth_lev) % B_o(NP))
       
       !C modified..
       !C mul_col => HIERARCHICAL_DATA(nth_lev) % multi_color


!!$       		VAL => HIERARCHICAL_DATA(nth_lev) % VAL_o
!!$       		COL => HIERARCHICAL_DATA(nth_lev) % COL_o
!!$       		IND => HIERARCHICAL_DATA(nth_lev) % IND_o
!!$       		B_o => HIERARCHICAL_DATA(nth_lev) % B_o


       call set_color(N,NP,D,AL,INL,IAL,AU,INU,IAU,mul_col,cnt)
       
       allocate(HIERARCHICAL_DATA(nth_lev) % color_index(0:cnt), &
            &	HIERARCHICAL_DATA(nth_lev) % INML(N))

       col_ind => HIERARCHICAL_DATA(nth_lev) % color_index
       INML    => HIERARCHICAL_DATA(nth_lev) % INML

       call indexing_color(N,cnt,mul_col,col_ind,INML)

!!$       		call matrix_ordering(N,NP,NPU,NPL,D,AL,INL,IAL,AU,INU,IAU,B,cnt,col_ind,INML,VAL,IND,COL,B_o)

       deallocate(mul_col)


       !C		write(*,*) 'LEVEL_NUM :',nth_lev,'N:',N,'color :',cnt
       HIERARCHICAL_DATA(nth_lev) % color = cnt
    END DO
  end subroutine amg_coloring

  subroutine set_color(N, NP, D, AL, INL, IAL, AU, INU, IAU, mul_col, color)

    use data_structure_for_AMG

    integer(kind=kint) , intent(in) :: N,NP
    real(kind=kreal) , dimension(:) , intent(in) :: D
    real(kind=kreal) , dimension(:) , intent(in) :: AL
    real(kind=kreal) , dimension(:) , intent(in) :: AU

    integer(kind=kint) , dimension(0:) , intent(in) :: INL
    integer(kind=kint) , dimension(0:) , intent(in) :: INU

    integer(kind=kint) , dimension(:) , intent(in) :: IAL
    integer(kind=kint) , dimension(:) , intent(in) :: IAU
    integer(kind=kint) , dimension(:) , intent(inout) :: mul_col
    integer(kind=kint) , intent(inout) :: color

    integer(kind=kint) , dimension(:) , allocatable :: ne_col

    logical :: flag1 = .false.

    integer(kind=kint) :: isU,ieU,isL,ieL,inod
    integer(kind=kint) :: i,j,k,l, cl
    real(kind=kreal) :: wei,max_val,min_val,m_abs

    allocate(ne_col(NP-1))

    wei=0
    mul_col(:) = 0
    ne_col(:) = 0
    color = 1
    max_val = 0.0

    !C modified..
    !C-----1ܤ˿Ĥ-----C!
    if(N>0) mul_col(1) = color
    k = 1

    !C-----2ܰʹ-----C!
    DO i = 2,N
       flag1 = .false.
       k = 1						!C-----ܥοĴ٤-----C!
       isL = INL(i-1) + 1
       ieL = INL(i)
       DO j = isL,ieL
          if(max_val < abs(AL(j))) then
             max_vaL = abs(AL(j))
          end if
       END DO
       isU = INU(i-1) + 1
       ieU = INU(i)
       DO j = isU,ieU
          if(max_val < abs(AU(j))) then
             max_vaL = abs(AU(j))
          end if
       END DO

       DO j = isL,ieL
          if(abs(AL(j)/max_val) < wei ) then
             cycle
          end if
          inod = IAL(j)
          ne_col(k) = mul_col(inod)
          k = k+1
       END DO


       DO j = isU,ieU
          if(abs(AU(j)/max_val) < wei ) then
             cycle
          end if
          inod = IAU(j)
          ne_col(k) = mul_col(inod)
          k = k+1
       END DO

       DO j = 1, color
          DO l = 1, k-1
             if(ne_col(l) == j) exit
          END DO
          if(l == k) then
             !C color is determined
             mul_col(i) = j 
             exit
          end if
       end DO
       if(j > color) then
          !C new color is allocated
          mul_col(i) = j
          color = color+1
       end if
    END DO
    
    !	DO i = 1,N
    !		write(*,*) i,': color :',mul_col(i)
    !	END DO

    deallocate(ne_col)

  end subroutine set_color

  subroutine indexing_color(N,cnt,multi_color,color_index,INML)

    use data_structure_for_AMG

    integer(kind=kint) , intent(in) :: N,cnt
    integer(kind=kint) , dimension(:) , intent(in) :: multi_color
    integer(kind=kint) , dimension(:) , intent(inout) :: INML
    integer(kind=kint) , dimension(0:) , intent(inout) :: color_index

    integer(kind=kint) i,j,k

    INML(:) = 0
    color_index(0:cnt) = 0

    k = 1

    DO i = 1, cnt
       DO j = 1,N
          if(multi_color(j) == i) then
             INML(k) = j
             k = k + 1
          end if
       END DO
       color_index(i) = k - 1
    END DO

    !	DO i = 1,N
    !		write(*,*) 'gyou',INML(i)
    !	END DO

    !	do i = 1,cnt
    !		write(*,*) 'col_row',color_index(i)-color_index(i-1)
    !	end do

  end subroutine indexing_color

!C modified.. comment out following three subs.

!!$  subroutine matrix_ordering(N,NP,NPU,NPL,D,AL,INL,IAL,AU,INU,IAU,B,cnt,col_ind,inml,VAL,IND,COL,B_o)
!!$
!!$    use data_structure_for_AMG
!!$    use omp_lib
!!$
!!$    integer	(kind=kint) , intent(in) :: N,NP,NPU,NPL
!!$    real	(kind=kreal) , dimension(:) , intent(in) :: AL
!!$    real	(kind=kreal) , dimension(:) , intent(in) :: D
!!$    real	(kind=kreal) , dimension(:) , intent(in) :: AU
!!$
!!$    integer (kind=kint), dimension(0:) , intent(in) :: INL
!!$    integer (kind=kint), dimension(0:) , intent(in) :: INU
!!$
!!$    integer (kind=kint), dimension(:) , intent(in) :: IAL
!!$    integer (kind=kint), dimension(:) , intent(in) :: IAU
!!$    real	(kind=kreal) , dimension(:) , intent(in) :: B
!!$
!!$    integer (kind=kint), intent(in) :: cnt
!!$    integer (kind=kint), dimension(0:) , intent (in) :: col_ind
!!$    integer (kind=kint), dimension(:) , intent (in) :: inml
!!$
!!$    real	(kind=kreal), dimension(:) , intent(inout) :: VAL
!!$    integer (kind=kint), dimension(0:) , intent(inout) :: IND
!!$    integer (kind=kint), dimension(:) , intent(inout) :: COL
!!$    real	(kind=kreal) , dimension(:) , intent(inout) :: B_o
!!$
!!$    integer (kind=kint) :: i,j,k,l,m,nonzero
!!$    integer (kind=kint) :: isU,ieU,isL,ieL,inod
!!$    integer (kind=kint) :: st,ed,id
!!$
!!$    nonzero = N + NPU + NPL
!!$    l = 1
!!$    m = 1
!!$    IND(0) = 0
!!$
!!$    !$omp parallel
!!$    !$omp do
!!$    DO i = 1,N
!!$       IND(i) = 0
!!$    END DO
!!$    !$omp end do
!!$    !$omp end parallel
!!$
!!$    !$omp parallel
!!$    !$omp do
!!$    DO i = 1,NP
!!$       B_o(i) = 0.0d0
!!$    END DO
!!$    !$omp end do
!!$    !$omp end parallel
!!$
!!$    !$omp parallel
!!$    !$omp do
!!$    DO i = 1,nonzero
!!$       VAL(i) = 0.0d0
!!$       COL(i) = 0
!!$    END DO
!!$    !$omp end do
!!$    !$omp end parallel
!!$
!!$    B_o(:) = B(:)
!!$
!!$    DO k = 1,cnt
!!$       st = col_ind(k-1) + 1
!!$       ed = col_ind(k)
!!$       DO i = st,ed
!!$          id = inml(i)
!!$          isL = INL(id-1) +1
!!$          ieL = INL(id)
!!$          DO j =isL,ieL
!!$             VAL(l) = AL(j)
!!$             COL(l) = IAL(j)
!!$             l = l+1
!!$          END DO
!!$          isU = INU(id-1) +1
!!$          ieU = INU(id)
!!$          DO j =isU,ieU
!!$             VAL(l) = AU(j)
!!$             COL(l) = IAU(j)
!!$             l = l+1
!!$          END DO
!!$          B_o(i) = B(id)
!!$          VAL(l) = D(id)
!!$          COL(l) = id
!!$          l = l+1
!!$          IND(i) = l-1
!!$       END DO
!!$    END DO
!!$
!!$  end subroutine matrix_ordering

!!$  subroutine vector_ordering(N,NP,coarser_B,nth_lev)
!!$
!!$    use data_structure_for_AMG
!!$    use omp_lib
!!$
!!$    integer(kind=kint),  intent(in)    :: nth_lev
!!$    integer(kind=kint), intent(in)    :: N,NP
!!$
!!$    integer(kind=kint ), dimension(:), pointer :: INML
!!$
!!$    REAL   (kind=kreal), DIMENSION(:) ,intent(in) ::  coarser_B
!!$
!!$    REAL   (kind=kreal), DIMENSION(:), pointer::  B_o
!!$
!!$    !C	integer (kind=kint), dimension(:), allocatable :: part
!!$    integer (kind=kint) :: i
!!$    integer (kind=kint) :: id
!!$
!!$    B_o => HIERARCHICAL_DATA(nth_lev+1) % B_o
!!$    INML => HIERARCHICAL_DATA(nth_lev+1) % INML
!!$
!!$    !C	allocate(part(N))
!!$    !C	part(:) = 0
!!$
!!$
!!$    B_o(:) = coarser_B(:)
!!$
!!$    !$omp parallel
!!$    !$omp do private(id)	
!!$    DO i = 1,N
!!$       id = inml(i)
!!$       B_o(i) = coarser_B(id)		
!!$    END DO
!!$    !$omp end do
!!$    !$omp end parallel
!!$
!!$
!!$
!!$    !	!$omp do private(id)	
!!$    !	DO i = N+1,NP
!!$    !		v_o(i) = v(i)		
!!$    !	END DO
!!$    !	!$omp end do
!!$    !	!$omp end parallel
!!$
!!$    !C	deallocate(part)
!!$
!!$  end subroutine vector_ordering

!!$  subroutine vector_reordering(N,NP,temp,nth_lev)
!!$
!!$    use data_structure_for_AMG
!!$    use omp_lib
!!$
!!$    integer(kind=kint),  intent(in)    :: nth_lev
!!$    integer(kind=kint),  intent(in)    :: N,NP
!!$
!!$    integer(kind=kint ), dimension(:), pointer :: INML
!!$
!!$    REAL   (kind=kreal), DIMENSION(:) ,intent(inout):: temp
!!$    real (kind=kreal), dimension(:), allocatable :: part
!!$
!!$    integer (kind=kint) :: i
!!$    integer (kind=kint) :: id
!!$
!!$    INML => HIERARCHICAL_DATA(nth_lev) % INML
!!$
!!$    allocate(part(N))
!!$    part(:) = 0.0d0
!!$
!!$    !$omp parallel
!!$    !$omp do private(id)	
!!$    DO i = 1,N
!!$       id = INML(i)
!!$       part(id) = temp(i)		
!!$    END DO
!!$    !$omp end do
!!$    !$omp do private(id)	
!!$    DO i = 1,N
!!$       temp(i) = part(i)		
!!$    END DO
!!$    !$omp end do
!!$    !$omp end parallel
!!$
!!$    deallocate(part)
!!$
!!$  end subroutine vector_reordering

END MODULE amg_multi_coloring
