!C   Copyright (C) 2010 High Performance Computing Laboratory, Kogakuin University.
!C   All rights reserved.
!C
!C   Redistribution and use in source and binary forms, with or without
!C   modification, are permitted provided that the following conditions are met:
!C   1. Redistributions of source code must retain the above copyright
!C      notice, this list of conditions and the following disclaimer.
!C   2. Redistributions in binary form must reproduce the above copyright
!C      notice, this list of conditions and the following disclaimer in the
!C      documentation and/or other materials provided with the distribution.
!C   3. Neither the name of the project nor the names of its contributors
!C      may be used to endorse or promote products derived from this software
!C      without specific prior written permission.
!C
!C   THIS SOFTWARE IS PROVIDED BY THE SCALABLE SOFTWARE INFRASTRUCTURE PROJECT
!C   ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
!C   TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
!C   PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE SCALABLE SOFTWARE INFRASTRUCTURE
!C   PROJECT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
!C   OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
!C   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
!C   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
!C   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
!C   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!C   POSSIBILITY OF SUCH DAMAGE.


MODULE amgs_p_module
  
  use problem_matrix, only: amgs_distribute_matrix => distribute_problem_matrix,&
       &  amgs_store_distributed_matrix => store_distributed_problem_matrix,    &
       &  amgs_store_problem_matrix     => store_problem_matrix,  &
       &  amgs_store_kernel_vecs        => store_kernel_vectors                 

  use common_mod, only: amgs_clear_matrices => clear_matrices, amgs_setup => setup_phase
  
  ! subroutines for terminal conditions
  use terminal_condition, only: amgs_terminal_val_set => terminal_cond_val_set, &
       &                        amgs_terminal_vec_set => terminal_cond_vec_set, &
       &                      amgs_terminal_vec_clear => terminal_cond_vec_clear

  !C parameter_at
  ! amg_parameter_set: 
  use parameter_at, only: amgs_solver => AMG_SOLVER, amgs_parameter_set=>amg_parameter_set, &
       &  amgs_parameter_set_w_val => amg_parameter_set_w_val, &
       &  amgs_parameter_set_w_val_test => amg_parameter_set_w_val_test,  &
       &  amgs_suggest_topology         => suggest_topology, &
       &  amgs_topology_setting_frm_file => topology_setting_from_file, &
       & amgs_parameter_set_alpha_beta => amg_parameter_set_alpha_beta, &
       & amgs_parameter_option=>amg_parameter_option, &
       & amgs_option_info=>print_amg_option_range, &
       & amgs_parameter_option_file=>amg_parameter_option_file

  !C output_data()
  use output_data, only: amgs_output_mat => output_mat_data
	
  use count_time_mod, only: amgs_get_solver_time => get_solver_time
  
end module amgs_p_module







