/** @file  boader_zone.h
    @brief ̿ơ֥륯饹ȽϤδؿŻƤ
    @author Kosuke Takahashi
 */

#ifndef __BOADER_ZONE_H
#define __BOADER_ZONE_H

#include <cuda_runtime.h>
#include <mpi.h>

#define NO_GPU_DIRECT_FLAG 1

/**
 * @class boader_zone
 * @brief ̿ơ֥륯饹
 */
class boader_zone
{
public:
	int neibpetot;  /**< PE */
	int nnz;        /**< ̿ǿ */
	int *neibpe;    /**< PE */
	int *ptr;       /**< PEǿݥ */
	int *index;     /**< ֹ */

	int *dev_index; /**< deviceǻȲǽʥꥪ󥰺Ѥֹ */

	double *buffer;         /**< deviceΥХåեΰ */
	double *host_buffer;    /**< hostΥХåեΰ */
	double **neibpe_buffer; /**< deviceΥХåեΰ */

	MPI_Status  *status;  /**< MPI_Status */
	MPI_Request *request; /**< MPI_Request */
	MPI_Comm    comm;     /**< MPI_Comm */

	cudaStream_t stream;  /**< deviceƱѤstream */

	char signal;          /**< device to deviceƱѤ륷ʥ̿ΰ */

	boader_zone();
	~boader_zone();

	/**
	 * boader_zoneγ
	 * @param [in] neibpetot PE	
	 * @param [in] nnz       ̿ǿ
	 * @retval 0 
	 * @retval 1 ۾
	 */
	int boader_zone_new(int neibpetot, int nnz);

	/**
	 * boader_zone0(˥ݥ󥿽)
	 * @retval 0 
	 * @retval 1 ۾
	 */
	int boader_zone_init();

	/**
	 * boader_zoneβ
	 * @retval 0 
	 * @retval 1 ۾
	 */
	int boader_zone_delete();

private:
	bool new_done; /**> deep copy  shallow coppy  */
};


int set_buffer(boader_zone *import_table, boader_zone *export_table, MPI_Comm solver_comm);
int send_border_zone(boader_zone *zone, int *order);

#endif
