MODULE comm_subs_NB
CONTAINS
  
  SUBROUTINE solver_SR_elements &
       &    ( SOLVER_COMM,my_rank,GIN_aggregate,NPROCS,hash_table_size,&
       &      global_local_hash_table,aggregate_table_size,            &
       &      aggregate_table_array,aggregate_number_in_table,         &
       &      local_aggre_size,PE_list,PE_list_size,Temp_CN,Temp_N,    &
       &      Temp_V,SIZE,NB) 
    USE hash_mod
    USE int_vec_module, only: int_vec, int_vec_initialize, check_and_extend

    implicit none
    include  'mpif.h'
    include  'precision.inc'

    INTEGER(kind=kint ), INTENT(in)    :: NPROCS,NB
!!$    INTEGER(kind=kint ), INTENT(in)    :: GIN_aggregate(0:NPROCS)
    INTEGER(kind=kint ), INTENT(in)    :: GIN_aggregate(0:)
    INTEGER(kind=kint ), INTENT(inout) :: PE_list_size
!!$    INTEGER(kind=kint )                :: PE_list(NPROCS,3)
    INTEGER(kind=kint )                :: PE_list(:,:)

    INTEGER(kind=kint ), INTENT(in) :: SOLVER_COMM
    INTEGER(kind=kint ), INTENT(in) :: my_rank
    INTEGER(kind=kint ), allocatable :: req1(:),req2(:)
    INTEGER(kind=kint ), allocatable :: sta1(:,:),sta2(:,:)
    INTEGER :: ierr

    INTEGER(kind=kint ), INTENT(inout) :: local_aggre_size

    INTEGER(kind=kint ), INTENT(in):: hash_table_size
    !C DIMENSION(hash_table_size,2)
!!$    INTEGER(kind=kint ), INTENT(inout) :: &
!!$         &  global_local_hash_table(hash_table_size,2)
    INTEGER(kind=kint ), INTENT(inout) :: &
         &  global_local_hash_table(:,:)

    INTEGER(kind=kint ), INTENT(in) :: aggregate_table_size
    !C two arguments: communication table,each PE
    type(int_vec), pointer :: aggregate_table_array(:)
    !C argument: the number of aggregates
!!$    INTEGER(kind=kint) :: aggregate_number_in_table(NPROCS)
    INTEGER(kind=kint) :: aggregate_number_in_table(:)
    
    INTEGER(kind=kint ), INTENT(in)    :: SIZE
    INTEGER(kind=kint ), INTENT(inout) :: Temp_N(:)
    REAL   (kind=kreal), INTENT(inout) :: Temp_V(:,:)
    INTEGER(kind=kint ), INTENT(inout) :: Temp_CN(:,:)

    INTEGER(kind=kint ) :: rs_in_buf_sz,sd_buf_sz,sd_in_buf_sz
    INTEGER(kind=kint ) :: sd_in_buf_index,sd_buf_index,rs_buf_sz,index_record
    INTEGER(kind=kint ), allocatable :: rs_pes(:)
    INTEGER(kind=kint ), allocatable :: in_sd_in_buf(:),in_sd_buf(:)
    INTEGER(kind=kint ), allocatable :: sd_in_buf(:),sd_row_glo_buf(:)
    INTEGER(kind=kint ), allocatable :: sd_col_glo_buf(:),rs_col_glo_buf(:)
    INTEGER(kind=kint ), allocatable :: rs_in_buf(:),rs_row_glo_buf(:)
    REAL   (kind=kreal), allocatable :: sd_values_buf(:),rs_values_buf(:)

    INTEGER(kind=kint ), allocatable :: in_recv_buf(:)

    INTEGER(kind=kint) :: dest,istart,inum
    INTEGER(kind=kint), allocatable :: LG_vector(:)

    INTEGER(kind=kint) :: i,j,k,l,g,ownnodes,buf_index,buf_size, m1
    INTEGER(kind=kint) :: in_buf_size,ins,ine,n,global_base,message_size
    INTEGER(kind=kint) :: row,col,global_bound,hash_no,hash_pointer
    INTEGER(kind=kint) :: count,n_pes,GLOBAL,LOCAL,m,rank,aggregate_number

    INTEGER(kind=kint), Allocatable :: pes_s(:), pes_r(:)


    INTEGER(kind=kint) , allocatable :: in_buf(:), row_glo_buf(:),col_glo_buf(:)
    logical :: hash_flag,pe_flag

    parameter(GLOBAL=1,LOCAL=2)

    ALLOCATE(pes_s(3 * NPROCS), pes_r(3 * NPROCS))


    !C-- LG_vector creation
    allocate(LG_vector(local_aggre_size))
    global_base  = GIN_aggregate(my_rank)
    global_bound = GIN_aggregate(my_rank+1)
    ownnodes     = global_bound-global_base

#ifdef DEBUG
    LG_vector=0
#endif

    !C create LG_vector
    DO i=1,ownnodes
       LG_vector(i) = i+global_base
    END DO

    DO i=1,PE_list_size
       DO j=1,aggregate_number_in_table(i)
          k = 2*j
          l = aggregate_table_array(i) % int_array(k)
          LG_vector(l) = aggregate_table_array(i) % int_array(k-1)
       END DO
    END DO

#ifdef DEBUG
    DO i=1,local_aggre_size
       if(LG_vector(i)==0) write(*,*) "Node", i , " is only for inter level communication."
    END DO
#endif
    !C-- end: LG_vector creation


    !C-- send buffer creation
    sd_in_buf_sz = 0
    sd_buf_sz    = 0
    DO i=1,PE_list_size
       in_buf_size  = aggregate_number_in_table(i)
       sd_in_buf_sz = sd_in_buf_sz+in_buf_size
       DO j=1,in_buf_size
          l = aggregate_table_array(i) % int_array(j*2)
          sd_buf_sz = sd_buf_sz + Temp_N(l)
       END DO
    END DO
    
    allocate(sd_in_buf     (sd_in_buf_sz+1))
    allocate(sd_row_glo_buf(sd_in_buf_sz+1))
    allocate(sd_col_glo_buf(sd_buf_sz+1))
    allocate(sd_values_buf ((sd_buf_sz+1)*NB*NB))

    allocate(in_sd_in_buf(0:PE_list_size))
    allocate(in_sd_buf   (0:PE_list_size))
    in_sd_in_buf(0)= 0
    in_sd_buf(0)   = 0

    pes_s=0
    sd_in_buf_index=0;sd_buf_index=0
    DO i=1,PE_list_size
       in_buf_size = aggregate_number_in_table(i)
       dest = PE_list(i,1)

       !C create index in in_buf of col_glo_buf  and values_buf
       DO j=1,in_buf_size
          l = aggregate_table_array(i) % int_array(j*2)
          k = j+sd_in_buf_index
          sd_in_buf(k)      = Temp_N(l)
          sd_row_glo_buf(k) = LG_vector(l)
       END DO
       sd_in_buf_index = sd_in_buf_index + in_buf_size

       buf_index=0
       DO j=1,in_buf_size
          l = aggregate_table_array(i) % int_array(j*2)
          DO k=1,SIZE
             if(Temp_CN(k,l)>0) then
                buf_index = buf_index+1
                m = buf_index+sd_buf_index
                sd_col_glo_buf(m) = LG_vector(Temp_CN(k,l))
                
                do m1 = 1, NB*NB
                   sd_values_buf((m-1)*NB*NB+m1)  = Temp_V((k-1)*NB*NB+m1,l)
                end do
             end if
          END DO
       END DO
       sd_buf_index = sd_buf_index + buf_index

       pes_s((dest+1)*3)   = buf_index
       pes_s((dest+1)*3-1) = in_buf_size
       pes_s((dest+1)*3-2) = 1

       in_sd_in_buf(i) = sd_in_buf_index
       in_sd_buf(i)    = sd_buf_index
    END DO

    deallocate(LG_vector)
    !C-- end: send buffer creation

    !C-- send recv
    !C-- exchange PEno,in_buf_size,buf_size
    pes_r = 0
    CALL MPI_ALLTOALL(pes_s, 3, MPI_INTEGER, pes_r, 3, MPI_INTEGER, &
         &            SOLVER_COMM, ierr)
    !C-- end: exchange in_buf_size,buf_size

    !C--    input from alltoall data
    n_pes=0;rs_in_buf_sz=0;rs_buf_sz=0
    DO i=1,NPROCS
       n_pes        = n_pes        + pes_r(i*3-2)
       rs_in_buf_sz = rs_in_buf_sz + pes_r(i*3-1)
       rs_buf_sz    = rs_buf_sz    + pes_r(i*3)
    END DO


    allocate(rs_in_buf     (rs_in_buf_sz+1) )
    allocate(rs_row_glo_buf(rs_in_buf_sz+1) )
    allocate(rs_col_glo_buf(rs_buf_sz+1)    )
    allocate(rs_values_buf (rs_buf_sz*NB*NB+1))

    allocate(rs_pes(n_pes))
    allocate(in_recv_buf(0:n_pes))

    j=0
    in_recv_buf(0)=0
    DO i=1,NPROCS
       if(pes_r(i*3-2)==1) then
          j=j+1
          rs_pes(j)=i-1
          in_recv_buf(j)=in_recv_buf(j-1)+pes_r(i*3-1)
       end if
    END DO
    !C--  alltoall data  input

    allocate(req1(PE_list_size))
    allocate(sta1(MPI_STATUS_SIZE,PE_list_size))
    allocate(req2(n_pes))
    allocate(sta2(MPI_STATUS_SIZE,n_pes))

    !C-- exchange 1: each row size of Temp_CN _N _V
    DO i = 1, PE_list_size
       dest  = PE_list(i,1)
       istart= in_sd_in_buf(i-1)
       inum  = in_sd_in_buf(i)-istart
       CALL MPI_ISEND(sd_in_buf(istart+1), inum, MPI_INTEGER,dest,20,  &
            &         SOLVER_COMM,req1(i),ierr)
    END DO

    DO i = 1, n_pes
       istart = in_recv_buf(i-1)
       inum   = in_recv_buf(i)-istart
       dest   = rs_pes(i) 
       CALL MPI_IRECV(rs_in_buf(istart+1),inum,MPI_INTEGER,dest,20,    &
            &         SOLVER_COMM,req2(i),ierr)
    END DO

    CALL MPI_WAITALL (n_pes,        req2, sta2, ierr)    
    CALL MPI_WAITALL (PE_list_size, req1, sta1, ierr)    
    !C-- end: exchange 1


    !C-- exchange 2: row number is exchanged
    DO i = 1, PE_list_size
       dest  = PE_list(i,1)
       istart= in_sd_in_buf(i-1)
       inum  = in_sd_in_buf(i)-istart
       CALL MPI_ISEND(sd_row_glo_buf(istart+1), inum, MPI_INTEGER,dest,&
            &         21,SOLVER_COMM,req1(i),ierr)
    END DO

    DO i=1,n_pes
       istart = in_recv_buf(i-1)
       inum   = in_recv_buf(i)-istart
       dest   = rs_pes(i)

       CALL MPI_IRECV(rs_row_glo_buf(istart+1),inum,MPI_INTEGER,dest,  &
            &         21,SOLVER_COMM,req2(i),ierr)
    END DO

    CALL MPI_WAITALL (n_pes,        req2, sta2, ierr)
    CALL MPI_WAITALL (PE_list_size, req1, sta1, ierr)    
    !C-- end: exchange 2

    !C-- change in_recv_buf(:)
    in_recv_buf(0)=0
    DO i=1,n_pes
       j = rs_pes(i)+1
       in_recv_buf(i)=in_recv_buf(i-1)+pes_r(j*3)
    END DO
    !C-- end:change in_recv_buf(:)

    !C-- exchange 3: column number is exchanged
    DO i=1,PE_list_size
       dest  = PE_list(i,1)
       istart= in_sd_buf(i-1)
       inum  = in_sd_buf(i)-istart
       CALL MPI_ISEND(sd_col_glo_buf(istart+1), inum, MPI_INTEGER,dest,22,&
            &         SOLVER_COMM,req1(i),ierr)
    END DO

    DO i=1,n_pes
       dest = rs_pes(i)
       istart = in_recv_buf(i-1)
       inum   = in_recv_buf(i)-istart
       CALL MPI_IRECV(rs_col_glo_buf(istart+1),inum,MPI_INTEGER,dest,22,  &
            &         SOLVER_COMM,req2(i),ierr)
    END DO

    CALL MPI_WAITALL (n_pes,        req2, sta2, ierr)          
    CALL MPI_WAITALL (PE_list_size, req1, sta1, ierr)          
    !C-- end: exchange 3


    !C-- exchange 4: value of Temp_N _CN _V is exchanged
    DO i=1,PE_list_size
       dest  = PE_list(i,1)
       istart= in_sd_buf(i-1)
       inum  = in_sd_buf(i)-istart
       CALL MPI_ISEND(sd_values_buf(istart*NB*NB+1), inum*NB*NB,          &
            &         MPI_DOUBLE_PRECISION,dest,23,SOLVER_COMM,req1(i),   &
            &         ierr)
    END DO

    DO i=1,n_pes
       istart = in_recv_buf(i-1)
       inum   = in_recv_buf(i)-istart
       dest   = rs_pes(i)

       CALL MPI_IRECV(rs_values_buf(istart*NB*NB+1),inum*NB*NB,           &
            &         MPI_DOUBLE_PRECISION,dest,23, SOLVER_COMM,req2(i),  &
            &         ierr)
    END DO

    CALL MPI_WAITALL (n_pes,        req2, sta2, ierr)
    CALL MPI_WAITALL (PE_list_size, req1, sta1, ierr)    
    !C-- end: exchange 4


    deallocate(in_sd_in_buf)
    deallocate(in_sd_buf)
    deallocate(in_recv_buf)
    deallocate(sd_in_buf)
    deallocate(sd_row_glo_buf)
    deallocate(sd_col_glo_buf)
    deallocate(sd_values_buf)
    deallocate(req1)
    deallocate(sta1)
    deallocate(req2)
    deallocate(sta2)
    !C-- end: send recv


    index_record=0
    DO j=1,rs_in_buf_sz
       ins = index_record+1
       ine = index_record+rs_in_buf(j)
       index_record = ine

       row = rs_row_glo_buf(j)-global_base
#ifdef DEBUG
       if(row>ownnodes) stop "unexpected error !! in sr_elements"
#endif
       DO k = ins,ine

          !C input data into associated location with hash function
          g = rs_col_glo_buf(k)
          !C  g in own aggregates
          !C  g not in own aggregates
          !C    g not in hashtable
          !C    g in hashtable
          if(global_base < g .and. g <= global_bound) then
             !C  g in own aggregates
             col=g-global_base

#ifdef DEBUG                  
             if(col<0) stop "not own-aggregate is send in sr_elements"
#endif                  

             !C assume symmetric case here
!!$             if(col<row)cycle
             !C search (row col) in new matrix


             CALL hash(SIZE, Temp_CN(:,row), col, count, "NONZEROS_PER_ROW")    

             !C assign the value
             if(Temp_CN(count,row)==col) then
                
                do m1 = 1, NB*NB
                   Temp_V((count-1)*NB*NB+m1,row) = Temp_V((count-1)*NB*NB+m1,row)+ &
                        & rs_values_buf((k-1)*NB*NB+m1)
                end do

             else
                
                Temp_N(row)=Temp_N(row)+1
                Temp_CN(count,row)=col
                do m1 = 1, NB*NB
                   Temp_V((count-1)*NB*NB+m1,row) = rs_values_buf((k-1)*NB*NB+m1)
                end do
             
             end if

          else
             !C  g in neigbor aggregates
             CALL hash(HASH_TABLE_SIZE, global_local_hash_table(1:HASH_TABLE_SIZE, GLOBAL), g, hash_pointer, "HASH_TABLE_SIZE")

             l = global_local_hash_table(hash_pointer,LOCAL)
             if(l==0) then
                !C g not in hashtable
                !C record the new node
                !C into hash_table
                local_aggre_size = local_aggre_size + 1
                global_local_hash_table(hash_pointer,GLOBAL) = g
                global_local_hash_table(hash_pointer,LOCAL)  = local_aggre_size
                l = local_aggre_size

                !C into aggregate_table_array
                DO m = 1, PE_list_size
                   rank = PE_list(m, 1)
                   if(GIN_aggregate(rank) < g .and. g <= GIN_aggregate(rank + 1)) then
                      exit
                   end if
                END DO

                if(m > PE_list_size)then
                   !C add new entry in PE_list in case of relayed node
                   DO n = 1, NPROCS
                      if(GIN_aggregate(n - 1) < g .and. g <= GIN_aggregate(n)) then
                         exit
                      end if
                   END DO
                   
                   if(n > NPROCS) then
                      write(*,*) "unknown node:solver_sr_elements:solver_Gnum: ",g
                      stop 
                   end if

                   PE_list_size = PE_list_size + 1
                   m = PE_list_size
                   PE_list(m,1) = n - 1
                   PE_list(m,2) = 0
                   PE_list(m,3) = 0
                   aggregate_number_in_table(m) = 0
                end if

                aggregate_number = aggregate_number_in_table(m)+1
                aggregate_number_in_table(m) = aggregate_number

                call check_and_extend(aggregate_table_array(m), aggregate_number * 2)
                aggregate_table_array(m) % int_array(aggregate_number * 2 - 1)= g
                aggregate_table_array(m) % int_array(aggregate_number * 2)    = l

                col=l
                !C search (row col) in new matrix
                CALL hash(SIZE, Temp_CN(:, row), col, count, "NONZEROS_PER_ROW")
                
                !C assign the value
                if(Temp_CN(count,row)==col) then
                   stop "solver_sr_element(): unsupported error!"
                else
                   Temp_N(row) = Temp_N(row) + 1
                   Temp_CN(count,row) = col
                   
                   do m1 = 1, NB*NB
                      Temp_V((count-1)*NB*NB+m1,row)=rs_values_buf((k-1)*NB*NB+m1)
                   end do
                   
                end if


             else
                !C  g in hashtable
                !C the case in which col is found in tables
                col=l

                CALL hash(SIZE, Temp_CN(:, row), col, count, "NONZEROS_PER_ROW")

                !C assign the value
                if(Temp_CN(count,row) == col) then
                   do m1 =1, NB*NB
                      Temp_V((count-1)*NB*NB+m1,row)= &
                           & Temp_V((count-1)*NB*NB+m1,row)+rs_values_buf((k-1)*NB*NB+m1)                      
                   end do
                else
                   Temp_N(row) = Temp_N(row) + 1
                   Temp_CN(count,row) = col
                   do m1 =1, NB*NB
                      Temp_V((count-1)*NB*NB+m1,row) = rs_values_buf((k-1)*NB*NB+m1)                      
                   end do
                   
                end if
             end if
          end if
       END DO
    END DO
    deallocate(rs_row_glo_buf)       
    deallocate(rs_in_buf)
    deallocate(rs_col_glo_buf)
    deallocate(rs_values_buf)
    DEALLOCATE(pes_s, pes_r)


  END SUBROUTINE solver_SR_elements


  SUBROUTINE  SOLVER_SR_REDUCE                                         &
       &                ( N, S,R,NEIBPETOT, NEIBPE, STACK_IMPORT, NOD_IMPORT, &
       &                                        STACK_EXPORT, NOD_EXPORT,     &
       &                  WS, WR, X, SOLVER_COMM,my_rank,NB)
    
    implicit none
    include  'mpif.h'
    include  'precision.inc'

    ! ......................................................................

    integer(kind=kint )                , intent(in)   ::  N, NB
    integer(kind=kint )                , intent(in)   ::  S
    integer(kind=kint )                , intent(in)   ::  R
    ! \beginARG       number of nodes
    integer(kind=kint )                , intent(in)   ::  NEIBPETOT
    ! \beginARG       total neighboring pe count
    integer(kind=kint ) :: NEIBPE      (:)
    ! \beginARG       neighboring pe id                        (i-th pe)
    integer(kind=kint ) :: STACK_IMPORT(0:)
    ! \beginARG       imported node count for each neighbor pe (i-th pe)
    integer(kind=kint ) :: NOD_IMPORT  (:)
    ! \beginARG       imported node                            (i-th dof)
    integer(kind=kint ) :: STACK_EXPORT(0:)
    ! \beginARG       exported node count for each neighbor pe (i-th pe)
    integer(kind=kint ) :: NOD_EXPORT  (:)
!!$    real   (kind=kreal), dimension(S*NB)  , intent(inout):: WS
    real   (kind=kreal), dimension(:)  , intent(inout):: WS
!!$    ! \beginARG       work array for communication (send)
!!$    real   (kind=kreal), dimension(R*NB)  , intent(inout):: WR
    real   (kind=kreal), dimension(:)  , intent(inout):: WR
!!$
!!$    real   (kind=kreal), dimension(N*NB)  , intent(inout):: X
    real   (kind=kreal), dimension(:)  , intent(inout):: X
    ! \beginARG       communicated result vector
    integer                            , intent(in)   ::SOLVER_COMM
    ! \beginARG       communicator for mpi
    integer                            , intent(in)   :: my_rank

    ! ....................................................................
    integer(kind=kint ), dimension(:,:), save, allocatable :: sta1
    ! \beginARG       work array for communication (wait)      
    integer(kind=kint ), dimension(:,:), save, allocatable :: sta2
    ! \beginARG       work array for communication (wait)      
    integer(kind=kint ), dimension(:  ), save, allocatable :: req1
    ! \beginARG       work array for communication (wait)    
    integer(kind=kint ), dimension(:  ), save, allocatable :: req2  
    ! \beginARG       work array for communication (wait)      
    ! \endSUBROUTINE
    
    
    integer(kind=kint) :: neib,istart,inum,k,ierr,i,ii,l
    integer(kind=kint ), save :: NFLAG=0
    integer(kind=kint ), save :: EARLIER_NEIBPETOT=0


    !C
    !C-- INIT.
    if (NFLAG.eq.0) then
       allocate (sta1(MPI_STATUS_SIZE,NEIBPETOT))
       allocate (sta2(MPI_STATUS_SIZE,NEIBPETOT))
       allocate (req1(NEIBPETOT))
       allocate (req2(NEIBPETOT))
       NFLAG= 1
       EARLIER_NEIBPETOT=NEIBPETOT
    else if(EARLIER_NEIBPETOT<NEIBPETOT)then
       deallocate(sta1);deallocate(sta2)
       deallocate(req1);deallocate(req2)
       allocate (sta1(MPI_STATUS_SIZE,NEIBPETOT))
       allocate (sta2(MPI_STATUS_SIZE,NEIBPETOT))
       allocate (req1(NEIBPETOT))
       allocate (req2(NEIBPETOT))
       EARLIER_NEIBPETOT=NEIBPETOT
    endif

    
    !C
    !C-- SEND
    
    do neib= 1, NEIBPETOT
       istart= STACK_IMPORT(neib-1)
       inum  = STACK_IMPORT(neib  ) - istart
       
       do k= istart+1, istart+inum
          ii   = NB*(NOD_IMPORT(k)-1)
          do l = 1, NB
             WR(NB*(k-1)+l) = X(ii+l)
          end do
!!$          WR(3*k-2) = X(ii-2)
!!$          WR(3*k-1) = X(ii-1)
!!$          WR(3*k  ) = X(ii  )
       enddo
       
#ifdef DEBUG
       if(istart+1>R .and. inum>0) write(*,*) "allocation error in send_recv",istart+1,R
#endif
       call MPI_ISEND (WR(NB*istart+1), NB*inum, MPI_DOUBLE_PRECISION, &
            &                  NEIBPE(neib), 0, SOLVER_COMM,           &
            &                  req1(neib), ierr)
    enddo

    !C
    !C-- RECEIVE

    do neib= 1, NEIBPETOT
       istart= STACK_EXPORT(neib-1)
       inum  = STACK_EXPORT(neib  ) - istart

#ifdef DEBUG
       if(istart+1>S .and. inum>0) write(*,*) "allocation error in send_recv",istart+1,S
#endif

       call MPI_IRECV (WS(NB*istart+1), NB*inum, MPI_DOUBLE_PRECISION,   &
            &                  NEIBPE(neib), 0, SOLVER_COMM,           &
            &                  req2(neib), ierr)
       
    enddo
    if(NEIBPETOT>0) call MPI_WAITALL (NEIBPETOT, req2, sta2, ierr)
    
    do neib= 1, NEIBPETOT
       istart= STACK_EXPORT(neib-1)
       inum  = STACK_EXPORT(neib  ) - istart
       do k = istart+1, istart+inum
          ii = NB*(NOD_EXPORT(k)-1)

          do l = 1, NB
             X(ii+l) = X(ii+l) + WS(NB*(k-1)+l)
          end do
!!$          X(ii-2) = X(ii-2) + WS(3*k-2)
!!$          X(ii-1) = X(ii-1) + WS(3*k-1)
!!$          X(ii  ) = X(ii  ) + WS(3*k  )
       enddo
    enddo

    if(NEIBPETOT>0) call MPI_WAITALL (NEIBPETOT, req1, sta1, ierr)
    
  END SUBROUTINE SOLVER_SR_REDUCE



  SUBROUTINE solver_SR_aggregates &
       &    ( PE_num_size, PE_nums, nfepe_size, nodes_for_each_PE, in_nodes_for_each_PE, SOLVER_COMM,  &
       &      temp_P_1,temp_P_2,Temp_P,Temp_PI, Temp_P_row_size, my_rank, GIN_aggregate, NPROCS,       &
       &      hash_table_size, global_local_hash_table, aggregate_table_size,              &
       &      aggregate_table_array, aggregate_number_in_table, local_aggre_size, PE_list, &
       &      PE_list_size, LEVEL_NO, NBf,NBc) 
    USE hash_mod
    USE data_structure_for_AMG_NB
    USE int_vec_module, &
         & only: int_vec, int_vec_initialize, check_and_extend, deallocate_int_vec

    IMPLICIT NONE
    INCLUDE  'mpif.h'

    INTEGER(kind=kint ), INTENT(IN) :: LEVEL_NO,NPROCS, nfepe_size 
    INTEGER(kind=kint ), INTENT(IN) :: temp_P_1,temp_P_2
    
    INTEGER(kind=kint)              :: NEIBPETOT
    INTEGER(kind=kint),POINTER      :: NEIBPE(:), STACK_IMPORT(:), STACK_EXPORT(:)
    INTEGER(kind=kint),POINTER      :: NOD_IMPORT(:), NOD_EXPORT(:)
    
    INTEGER(kind=kint ), INTENT(IN) :: PE_num_size
!!$    INTEGER(kind=kint ), INTENT(IN) :: PE_nums(1:PE_num_size)
    INTEGER(kind=kint ), INTENT(IN) :: PE_nums(:)
!!$    INTEGER(kind=kint ), INTENT(IN) :: nodes_for_each_PE(1:nfepe_size)
    INTEGER(kind=kint ), INTENT(IN) :: nodes_for_each_PE(:)
!!$ in_nodes_for_each_PE is allocated as array(0:PE_num_size+1)
!!$    INTEGER(kind=kint ), INTENT(IN) :: in_nodes_for_each_PE(0:PE_num_size)
    INTEGER(kind=kint ), INTENT(IN) :: in_nodes_for_each_PE(0:)
!!$    TYPE(row_node), INTENT(INOUT)      :: Temp_P(1:temp_P_1,1:temp_P_2)
!    TYPE(row_node), INTENT(INOUT)      :: Temp_P(:,:)
     REAL   (kind=kreal), intent(inout), DIMENSION(:,:)           :: Temp_P
     INTEGER(kind=kint ), intent(inout), DIMENSION(:,:)           :: Temp_PI

!!$    INTEGER(kind=kint ), INTENT(INOUT) :: Temp_P_row_size(1:temp_P_2)
    INTEGER(kind=kint ), INTENT(INOUT) :: Temp_P_row_size(:)

    INTEGER(kind=kint ), INTENT(inout) :: PE_list_size
!!$    INTEGER(kind=kint ), INTENT(inout) :: PE_list(1:NPROCS,1:3)
    INTEGER(kind=kint ), INTENT(inout) :: PE_list(:,:)

    
    INTEGER(kind=kint ), INTENT(in) :: GIN_aggregate(0:NPROCS)

    
    INTEGER(kind=kint ), INTENT(in) :: SOLVER_COMM
    INTEGER(kind=kint ), INTENT(in) :: my_rank
    INTEGER(kind=kint ), ALLOCATABLE :: req1(:),req2(:)
    INTEGER(kind=kint ), ALLOCATABLE :: sta1(:,:),sta2(:,:)
    INTEGER(kind=kint) :: ierr, req1_sz, req2_sz

    INTEGER(kind=kint ), ALLOCATABLE :: in_send_buf_for_PEs(:),in_send_buf_for_PEs_dbl(:)

    INTEGER(kind=kint ), INTENT(out) :: local_aggre_size

    INTEGER(kind=kint ) :: PE_list_alloc_size,istart,inum

    INTEGER(kind=kint) :: Neib_index,Pe_num_index,pack_index,pack_index_dbl,dest,  &
         &                src,message_size
    INTEGER(kind=kint) :: i,j,k,l,l1,l2,m,n,g,GLOBAL,LOCAL,hash_no,index,h,own_aggre_size,pls

    INTEGER(kind=kint), ALLOCATABLE :: LG_vector(:)

    INTEGER(kind=kint) :: recv_buf_size,recv_buf_size_dbl
    INTEGER(kind=kint) :: send_buf_size,wait_count,send_buf_size_dbl
    INTEGER(kind=kint) :: position,position_dbl
    PARAMETER(GLOBAL=1,LOCAL=2)    
    INTEGER(kind=kint ),ALLOCATABLE :: send_buf    (:), recv_buf    (:)
    REAL   (kind=kreal),ALLOCATABLE :: send_buf_dbl(:), recv_buf_dbl(:)


    INTEGER(kind=kint),INTENT(in):: HASH_TABLE_SIZE
    !C DIMENSION(hash_table_size,2)
!!$    INTEGER(kind=kint), INTENT(out) :: global_local_hash_table(1:HASH_TABLE_SIZE, 1:2)
    INTEGER(kind=kint), INTENT(out) :: global_local_hash_table(:, :)


    INTEGER(kind=kint),INTENT(in) :: aggregate_table_size

    !C two arguments: communication table,each PE
    type(int_vec), pointer :: aggregate_table_array(:)

    !C argument: the number of aggregates
!!$    INTEGER(kind=kint), INTENT(inout) :: aggregate_number_in_table(1:NPROCS)
    INTEGER(kind=kint), INTENT(inout) :: aggregate_number_in_table(:)

    INTEGER(kind=kint), allocatable ::s_ary(:), r_ary(:)

    INTEGER(kind=kint) :: NP,NBf,NBc
#ifdef DEBUG
    INTEGER(kind=kint),ALLOCATABLE :: deb1(:),deb2(:)

#endif



    NP = HIERARCHICAL_DATA_NB(LEVEL_NO-1) % NP
    
    NEIBPETOT     =  HIERARCHICAL_DATA_NB(LEVEL_NO-1) % COMM_TABLE % NEIBPETOT
    NEIBPE        => HIERARCHICAL_DATA_NB(LEVEL_NO-1) % COMM_TABLE % NEIBPE
    STACK_IMPORT  => HIERARCHICAL_DATA_NB(LEVEL_NO-1) % COMM_TABLE % STACK_IMPORT
    NOD_IMPORT    => HIERARCHICAL_DATA_NB(LEVEL_NO-1) % COMM_TABLE % NOD_IMPORT
    STACK_EXPORT  => HIERARCHICAL_DATA_NB(LEVEL_NO-1) % COMM_TABLE % STACK_EXPORT
    NOD_EXPORT    => HIERARCHICAL_DATA_NB(LEVEL_NO-1) % COMM_TABLE % NOD_EXPORT

    global_local_hash_table = 0

    !C-- count up the external aggregates and set local_aggre_size
    j=0
    DO i=1,PE_list_size
       j=j+aggregate_number_in_table(i)
    END DO

    ALLOCATE(LG_vector(j), s_ary(-1:2*NPROCS), r_ary(-1:2*NPROCS))
    own_aggre_size   = GIN_aggregate(my_rank+1)-GIN_aggregate(my_rank)
    local_aggre_size = own_aggre_size+j
    !C-- end:count up the external aggregates and set local_aggre_size


    !C-- assign aggregate_table_array into hash_table, and create LG_vector(:)    
    LG_vector=0

    DO i = 1, PE_list_size
       j = aggregate_number_in_table(i)
       DO k = 1, j
          g = aggregate_table_array(i) % int_array(2 * k - 1)
          l = aggregate_table_array(i) % int_array(2 * k)
          LG_vector(l - own_aggre_size) = g
          
          
          CALL hash_zero(HASH_TABLE_SIZE, global_local_hash_table(:, GLOBAL), g,  &
               &         h, "HASH_TABLE_SIZE")
          global_local_hash_table(h, GLOBAL) = g
          global_local_hash_table(h, LOCAL ) = l
       END DO
    END DO
    !C-- end:assign aggregate_table_array into hash_table    
    
    

    !C-- PE_list is extened, so original size is stored in pls.
    do i = 1, PE_list_size
       if(PE_list(i,2) == 0 .and. PE_list(i,3) == 0) exit
    end do
    pls = i-1
    
    !C-- count up  Send bufsize and make in_send_buf_for_PEs
    send_buf_size    = 0
    send_buf_size_dbl= 0
    ALLOCATE(in_send_buf_for_PEs    (0:PE_list_size))
    ALLOCATE(in_send_buf_for_PEs_dbl(0:PE_list_size))
    in_send_buf_for_PEs    (0)=0
    in_send_buf_for_PEs_dbl(0)=0
!!$    DO i=1,PE_list_size
    DO i=1,pls
       dest         = PE_list(i,1)       
       Neib_index   = PE_list(i,2)
       PE_num_index = PE_list(i,3)
       IF(Neib_index > 0) THEN
          j=STACK_IMPORT(NEIBPETOT)
          CALL count_NOD(STACK_IMPORT(0:NEIBPETOT),NOD_IMPORT(1:j),               &
               &        Temp_P_row_size(1:NP),SOLVER_COMM,                  &
               &        send_buf_size,send_buf_size_dbl,Neib_index,               &
               &        NP,NEIBPETOT)
          j=STACK_EXPORT(NEIBPETOT)
          CALL count_NOD(STACK_EXPORT(0:NEIBPETOT),NOD_EXPORT(1:j),               &
               &        Temp_P_row_size(1:NP),SOLVER_COMM,                  &
               &        send_buf_size,send_buf_size_dbl,Neib_index,               &
               &        NP,NEIBPETOT)
       END IF
       IF(PE_num_index > 0) THEN
          !C   PE_num_size,PE_nums,in_nodes_for_each_PE,nodes_for_each_PE
          j = in_nodes_for_each_PE(PE_num_size)
          CALL count_NOD(in_nodes_for_each_PE(0:PE_num_size), &
               &        nodes_for_each_PE(1:j),Temp_P_row_size(1:NP),&
               &        SOLVER_COMM,send_buf_size,send_buf_size_dbl,PE_num_index,    &
               &        NP, PE_num_size)

       END IF
       in_send_buf_for_PEs    (i) = send_buf_size
       in_send_buf_for_PEs_dbl(i) = send_buf_size_dbl

    END DO


    ALLOCATE(send_buf    (send_buf_size+1    ))
    ALLOCATE(send_buf_dbl((send_buf_size_dbl)*NBf*NBc+1))
    !C-- end: count up  Send bufsize and make in_send_buf_for_PEs
    

    !C-- sendrecv  in_send_buf_for_PEs
    ALLOCATE(req1(PE_list_size))
    ALLOCATE(req2(PE_list_size))
    ALLOCATE(sta2(MPI_STATUS_SIZE,PE_list_size))
    ALLOCATE(sta1(MPI_STATUS_SIZE,PE_list_size))




    r_ary=0
    req2_sz=0
!!$    DO i=1,PE_list_size
    DO i=1,pls
       src=PE_list(i,1)
       Neib_index   = PE_list(i,2)
       PE_num_index = PE_list(i,3)
       if(Neib_index > 0 .or. PE_num_index > 0) then
          req2_sz = req2_sz+1
          CALL MPI_IRECV(r_ary(i*2-1), 2, MPI_INTEGER, src, 0, SOLVER_COMM, &
               &         req2(req2_sz), ierr)
       end if
    END DO



    s_ary=0
!!$    DO i=1,PE_list_size
    DO i=1,pls
       s_ary(i*2-1)=in_send_buf_for_PEs    (i)-in_send_buf_for_PEs    (i-1)
       s_ary(i*2)  =in_send_buf_for_PEs_dbl(i)-in_send_buf_for_PEs_dbl(i-1)
    END DO

    req1_sz=0
!!$    DO i=1,PE_list_size
    DO i=1,pls
       dest=PE_list(i,1)
       Neib_index   = PE_list(i,2)
       PE_num_index = PE_list(i,3)
       if(Neib_index > 0 .or. PE_num_index > 0) then
          req1_sz=req1_sz+1
          CALL MPI_ISEND(s_ary(2*i-1), 2, MPI_INTEGER, dest, 0, SOLVER_COMM, &
               &         req1(req1_sz), ierr)
       end if
    END DO
    !C-- end: sendrecv in_send_buf_for_PEs




    !C-- Create Send buffer for neighboring PEs
    !C PE_list,in_send_buf_for_PEs has data from 1 to PE_list_size.
    !C position is the next space for packing.
!!$    DO i=1,PE_list_size
    DO i=1,pls
       dest=PE_list(i,1)
       Neib_index=PE_list(i,2)
       PE_num_index=PE_list(i,3)
       pack_index    = in_send_buf_for_PEs    (i-1)
       pack_index_dbl= in_send_buf_for_PEs_dbl(i-1)

       CALL create_buf(dest, Neib_index, PE_num_index, NEIBPETOT, NEIBPE,        &
            &  STACK_IMPORT, NOD_IMPORT, STACK_EXPORT, NOD_EXPORT, PE_num_size,  &
            &  PE_nums, nodes_for_each_PE, in_nodes_for_each_PE, Temp_P,Temp_PI, &
            &  Temp_P_row_size, send_buf(1:send_buf_size), send_buf_size, send_buf_dbl,&
            &  send_buf_size_dbl, my_rank, GIN_aggregate(my_rank),               &
            &  SOLVER_COMM, pack_index, pack_index_dbl, own_aggre_size,          &
            &  LG_vector, NBf, NBc)
    END DO

    DEALLOCATE(LG_vector)
    !C-- end:Create Send buffer for neighboring PEs




    !C-- wait sendrecv of in_send_buf_for_PEs
    !C   r_ary is index of recv_buf(:)
    CALL MPI_WAITALL (req2_sz, req2, sta1, ierr)
    CALL MPI_WAITALL (req1_sz, req1, sta2, ierr)

    r_ary(0)=0;r_ary(-1)=0


!!$    DO i=1,PE_list_size
    DO i=1,pls
       r_ary(2*i-1)=r_ary(2*i-3) +r_ary(2*i-1)
       r_ary(2*i)  =r_ary(2*i-2) +r_ary(2*i)
    END DO
    !C-- end:  wait sendrecv of in_send_buf_for_PEs

    
    !C-- communication the aggregates on border table of PE_list and input.
    !C   in this part PE_list(:) means neighboring pes within two path.
!!$    pls=PE_list_size
    recv_buf_size    =r_ary(pls*2-1)
    recv_buf_size_dbl=r_ary(pls*2)
    ALLOCATE(recv_buf(recv_buf_size+1))
    ALLOCATE(recv_buf_dbl(recv_buf_size_dbl*NBf*NBc+1))

    req2_sz = 0
    DO i=1,pls
       src=PE_list(i,1)
       istart = r_ary(2*i-3)
       inum   = r_ary(2*i-1)-istart
       if(inum > 0 ) then
          req2_sz = req2_sz+1
          CALL MPI_IRECV(recv_buf(istart+1), inum, MPI_INTEGER, src, 30, SOLVER_COMM, &
               &         req2(req2_sz),ierr)
       end if
    END DO
    

    req1_sz = 0
    DO i=1,pls
       dest=PE_list(i,1)
       istart = in_send_buf_for_PEs(i-1)
       inum   = in_send_buf_for_PEs(i)-istart

       if(inum > 0) then
          req1_sz = req1_sz+1
          CALL MPI_ISEND(send_buf(istart+1), inum, MPI_INTEGER, dest, 30, SOLVER_COMM,&
               &         req1(req1_sz),ierr)
       end if

    END DO


    CALL MPI_WAITALL(req2_sz, req2, sta2, ierr)
    CALL MPI_WAITALL(req1_sz, req1, sta1, ierr)

    req2_sz = 0
    DO i=1,pls
       src=PE_list(i,1)
       istart = r_ary(2*i-2)
       inum   = r_ary(2*i)-istart
       
       if(inum > 0) then
          req2_sz = req2_sz + 1
          CALL MPI_IRECV(recv_buf_dbl(istart*NBf*NBc+1),inum*NBf*NBc,MPI_DOUBLE_PRECISION,src,31,SOLVER_COMM, &
               &         req2(req2_sz),ierr)
       end if
    END DO

    req1_sz = 0
    DO i=1,pls
       dest=PE_list(i,1)
       istart = in_send_buf_for_PEs_dbl(i-1)
       inum   = in_send_buf_for_PEs_dbl(i)-istart
       if(inum>0) then
          req1_sz = req1_sz + 1
          CALL MPI_ISEND(send_buf_dbl(istart*NBf*NBc+1),inum*NBf*NBc, MPI_DOUBLE_PRECISION,dest,31,SOLVER_COMM,&
               &         req1(req1_sz),ierr)
       end if
    END DO

    CALL MPI_WAITALL(req2_sz, req2, sta2, ierr)
    CALL MPI_WAITALL(req1_sz, req1, sta1, ierr)


    !C UNPACK should be done in accordance with  PE_list()
    !C PE_list_size is changed
    DO i = 1,pls
       src = PE_list(i,1)
       Neib_index = PE_list(i,2)
       PE_num_index = PE_list(i,3)
       j=r_ary(2*i-3)+1; k=r_ary(2*i-1)
       m=r_ary(2*i-2)*NBf*NBc+1; n=r_ary(2*i)*NBf*NBc
       l1=k-j+1;l2=n-m+1

       position=0
       position_dbl=0


       IF(Neib_index /= 0) THEN
          !C receive NOD_EXPORT and NOD_IMPORT
          CALL input_buf(Neib_index, Temp_P, Temp_PI, Temp_P_row_size, recv_buf(j:k), recv_buf_dbl(m:n), &
               & hash_table_size, global_local_hash_table, position, position_dbl,              &
               & STACK_EXPORT, NOD_EXPORT, aggregate_table_size, aggregate_table_array,         &
               & aggregate_number_in_table, local_aggre_size, SOLVER_COMM, my_rank, l1, l2,     &
               & GIN_aggregate, PE_list_size, PE_list, NPROCS, NBf, NBc)

          CALL input_buf(Neib_index, Temp_P, Temp_PI,Temp_P_row_size, recv_buf(j:k), recv_buf_dbl(m:n), &
               & HASH_TABLE_SIZE, global_local_hash_table, position, position_dbl,              &
               & STACK_IMPORT, NOD_IMPORT, aggregate_table_size, aggregate_table_array,         &
               & aggregate_number_in_table, local_aggre_size, SOLVER_COMM, my_rank, l1, l2,     &
               & GIN_aggregate, PE_list_size, PE_list, NPROCS, NBf, NBc)

       END IF
       IF(PE_num_index /= 0 ) THEN
          !C receive (in_nodes_for_each_PE, nodes_for_each_PE)
          CALL input_buf(PE_num_index, Temp_P, Temp_PI,Temp_P_row_size, recv_buf(j:k),                &
               & recv_buf_dbl(m:n), hash_table_size, global_local_hash_table, position,       &
               & position_dbl, in_nodes_for_each_PE, nodes_for_each_PE, aggregate_table_size, &
               & aggregate_table_array, aggregate_number_in_table, local_aggre_size,          &
               & SOLVER_COMM, my_rank, l1, l2, GIN_aggregate, PE_list_size, PE_list, NPROCS,  &
               & NBf, NBc)

       END IF
    END DO


    DEALLOCATE(send_buf)     
    DEALLOCATE(send_buf_dbl)     
    DEALLOCATE(in_send_buf_for_PEs)
    DEALLOCATE(in_send_buf_for_PEs_dbl)
    DEALLOCATE(recv_buf)
    DEALLOCATE(recv_buf_dbl)
    DEALLOCATE(req1)
    DEALLOCATE(req2)
    DEALLOCATE(sta1)
    DEALLOCATE(sta2)
    DEALLOCATE(s_ary, r_ary)    
    !C-- communication the aggregates on border table of PE_list and input.



#ifdef DEBUG
    DO i = 1, PE_list_size
       DO j = 1, aggregate_number_in_table(i)
          k = 2 * j
          l = aggregate_table_array(i) % int_array(k - 1)
          dest  = PE_list(i, 1)
          IF(l <= GIN_aggregate(dest) .OR. l > GIN_aggregate(dest + 1)) THEN
             WRITE(*,*)"error in sr_aggregates:", l, GIN_aggregate(dest), GIN_aggregate(dest + 1), dest
             STOP "aggregate_table_array is corrupted : sr_aggregate "
          END IF
       END DO
    END DO
#endif

    
  contains

    subroutine count_NOD(STACK_PORT,NOD_PORT,Temp_P_row_size,solver_comm, &
         &              send_buf_size,send_buf_size_dbl,Neib_index,NPT_sz,&
         &              TP_sz)
      
      implicit none
!!$      include  'mpif.h'
!!$      include  'precision.inc'

      INTEGER(kind=kint), DIMENSION(0:),INTENT(in) :: STACK_PORT
      INTEGER(kind=kint), DIMENSION(:),INTENT(in)  :: NOD_PORT,Temp_P_row_size
      INTEGER(kind=kint), INTENT(in)    :: Neib_index,NPT_sz,TP_sz
      INTEGER(kind=kint), INTENT(inout) :: send_buf_size,send_buf_size_dbl
      INTEGER,INTENT(in)                :: SOLVER_COMM

      INTEGER :: ierr,in_buf_size,membersize
      INTEGER(kind=kint) :: i,node_index_base,buf_size,node


      !C in_buf(0:in_buf_size)
      !C aggregate_num_buf(buf_size)
      !C value_buf(buf_size)
      node_index_base = STACK_PORT(Neib_index-1)
      in_buf_size = STACK_PORT(Neib_index)-node_index_base
      



      buf_size=0
      DO i = 1,in_buf_size
         node = NOD_PORT(node_index_base+i)
         buf_size = buf_size+Temp_P_row_size(node) 
      END DO
      
      !C first MPI_INTEGER is the size of in_buf
      !C zero:in_buf(0) is not sended.
      
      send_buf_size     = send_buf_size+1+1+in_buf_size+buf_size
      send_buf_size_dbl = send_buf_size_dbl+buf_size
      
    end subroutine count_NOD
    
    
!!$
!!$!C side effect: index,Temp_P,Temp_P_row_size,global_local_hash_table,
!!$!C              position,aggregate_table_size,aggregate_table_each_PE,
!!$!C              aggregate_number,local_aggre_size
!!$
    subroutine input_buf (index,Temp_P,Temp_PI,Temp_P_row_size, recv_buf, &
         &                recv_buf_dbl,hash_table_size,                   &
         &                global_local_hash_table,position,position_dbl,  &
         &                STACK_PORT,NOD_PORT,aggregate_table_size,       &
         &                aggregate_table_array,aggregate_number_in_table,&
         &                local_aggre_size,SOLVER_COMM,my_rank,l1,l2,     &
         &                GIN_aggregate,PE_list_size,PE_list,NPROCS,NBf,NBc)
      USE int_vec_module, only: int_vec, int_vec_initialize, check_and_extend
    
      implicit none
!!$      include 'mpif.h'
!!$      include 'precision.inc'

      INTEGER(kind=kint), INTENT(in) :: my_rank, NPROCS,l1,l2,NBf,NBc
      INTEGER(kind=kint), INTENT(inout) :: PE_list_size
      INTEGER(kind=kint), INTENT(inout) :: PE_list(:,:)

      !C max number of local aggregate number
      INTEGER(kind=kint), INTENT(inout) :: local_aggre_size
      !C comunication table is one dimensional array of aggregate_table_size*2
      INTEGER(kind=kint), INTENT(in) :: aggregate_table_size
      !C communication table: global,local
      type(int_vec), pointer :: aggregate_table_array(:)
      !C argument: the number of aggregates
      INTEGER(kind=kint), INTENT(inout) :: aggregate_number_in_table(:)

      INTEGER(kind=kint), INTENT(inout) :: position,position_dbl    
      INTEGER(kind=kint), INTENT(in)    :: STACK_PORT(0:)
      INTEGER(kind=kint), INTENT(in)    :: NOD_PORT(:)
      INTEGER(kind=kint), INTENT(in)    :: index

      INTEGER(kind=kint), INTENT(in)    :: GIN_aggregate(0:)

      INTEGER(kind=kint) :: GLOBAL,LOCAL
      parameter(GLOBAL=1,LOCAL=2)


      REAL   (kind=kreal), INTENT(inout) :: Temp_P(:,:)
      INTEGER(kind=kint ), INTENT(inout) :: Temp_PI(:,:)
      INTEGER(kind=kint ), INTENT(inout) :: Temp_P_row_size(:)

      INTEGER(kind=kint ), TARGET,INTENT(in) :: recv_buf(l1)
      REAL   (kind=kreal), TARGET,INTENT(in) :: recv_buf_dbl(l2)
      INTEGER(kind=kint ), INTENT(in)    :: hash_table_size
      INTEGER(kind=kint ), INTENT(inout) :: global_local_hash_table(:,:)
      INTEGER,INTENT(in) :: SOLVER_COMM

      INTEGER :: ierr

      logical :: hash_flag,Temp_flag
      INTEGER(kind=kint ) :: i,j,k,l,m,Neib_index,PE_num_index,buf_size
      INTEGER(kind=kint ) :: ins,ine,g_ag_no,local_ag_no,hash_no,row,base
      INTEGER(kind=kint ) :: geta_NOD_PORT,bound,pe
      REAL   (kind=kreal) :: value
      INTEGER(kind=kint ) :: buf_node_size
      INTEGER(kind=kint ), pointer :: buf_index(:)
      INTEGER(kind=kint ), pointer :: buf_of_global_aggregate_number(:)
      REAL   (kind=kreal), pointer :: buf_of_value(:)

      base  = GIN_aggregate(my_rank)
      bound = GIN_aggregate(my_rank+1)

      !C buf_node_size
      position=position+1
      buf_node_size=recv_buf(position)
      
      !C buf_index
      buf_size=0
      if(buf_node_size>0)then
         !C  buf_index starts from 0.
         buf_index => recv_buf((position+1):(position+buf_node_size+1))
         buf_size  =  buf_index(buf_node_size+1)
      end if
      position=position+buf_node_size+1

      !C buf_of_global_aggregate_number,and buf_of_value
      if(buf_size > 0) then
         buf_of_global_aggregate_number => recv_buf((position+1):(position+buf_size))
         buf_of_value => recv_buf_dbl((position_dbl*NBf*NBc+1):((position_dbl+buf_size)*NBf*NBc))
         position     = position     + buf_size
         position_dbl = position_dbl + buf_size
      end if
      
      geta_NOD_PORT=STACK_PORT(index-1)
      DO i=1,buf_node_size
         !C buf_index starts from 1
         ins=buf_index(i+1-1)+1
         ine=buf_index(i+1)

         DO j = ins, ine
            g_ag_no = buf_of_global_aggregate_number(j)
!!$            value=buf_of_value(j)

            !C g_ag_no in own aggregates
            !C g_ag_no not in own aggregates
            !C   g_ag_no not in hash_table
            !C   g_ag_no in hash_table

            if(base < g_ag_no .and. g_ag_no <= bound)  then
               local_ag_no = g_ag_no-base
            else
               !C-- insert g_ag_no to hash_table
               !C hash_table should be initialized to (0,0).
               hash_no = mod(g_ag_no,hash_table_size)+1
               hash_flag = .false.
               k = hash_no

               DO while(k<=hash_table_size)
                  if(global_local_hash_table(k,GLOBAL)==0 .or. &
                       & global_local_hash_table(k,GLOBAL)==g_ag_no) exit
                  k = k+1
               END DO
               
               if(k>hash_table_size) then
                  k=1
                  DO while(k<hash_no .and. global_local_hash_table(k,GLOBAL)/=0 .and. &
                       & global_local_hash_table(k,GLOBAL)/=g_ag_no)
                     k=k+1
                  END DO
                  if(k>=hash_no)  stop "global_local_hash_table:input_buf:solver_Gnum.f90"
               END if
               local_ag_no=global_local_hash_table(k,LOCAL)
            end if

            if(local_ag_no==0) then
               !C local_ag_no not in hashtable
               !C record the new aggregate
               local_aggre_size = local_aggre_size+1
               global_local_hash_table(k,GLOBAL) = g_ag_no
               global_local_hash_table(k,LOCAL)  = local_aggre_size
               local_ag_no = local_aggre_size

               !C -- begin: insert aggregate number into aggregate_table_array
               DO k=1,PE_list_size
                  l=PE_list(k,1)
                  if(GIN_aggregate(l) < g_ag_no .and. g_ag_no <= GIN_aggregate(l+1)) exit
               END DO
               if(k > PE_list_size)then 
                  DO pe=0,NPROCS-1
                     if(GIN_aggregate(pe)<g_ag_no .and. g_ag_no<=GIN_aggregate(pe+1)) exit                    
                  END DO
                  if(pe >= NPROCS) stop "unexpected error!! in input_buf()"
                  k=PE_list_size+1
                  PE_list_size=k
                  PE_list(k,1) = pe
                  PE_list(k,2) = 0
                  PE_list(k,3) = 0
                  aggregate_number_in_table(k) = 0
               end if
               
               aggregate_number_in_table(k)=aggregate_number_in_table(k)+1
               m=aggregate_number_in_table(k)
               call check_and_extend(aggregate_table_array(k), m*2)
               aggregate_table_array(k) % int_array(m*2-1) = g_ag_no
               aggregate_table_array(k) % int_array(m*2)   = local_ag_no
               !C -- end: insert aggregat number into aggregate_table_array

               !C-- insert node to Temp_P
               !C row is node number, column is aggregate number sent by other PE
               row=NOD_PORT(i+geta_NOD_PORT)

               k=Temp_P_row_size(row)+1
               Temp_P_row_size(row)=k
               
               Temp_PI(k,row) = local_ag_no
               
               DO m = 1, NBf*NBc
                  Temp_P((k-1)*NBf*NBc+m,row) = buf_of_value((j-1)*NBf*NBc+m)
               END DO
               !C-- end: insert node to Temp_P
            else
               !C-- insert node to Temp_P : insertion by local_ag_no
               row = NOD_PORT(i+geta_NOD_PORT)
               k   = Temp_P_row_size(row)

               l=1
               DO while( l <= k .and. Temp_PI(l,row) < local_ag_no) 
                  l = l+1
               end DO
               
               if( l <= k .and. Temp_PI(l,row) == local_ag_no) then
                  DO m = 1, NBf*NBc
                     Temp_P((l-1)*NBf*NBc+m,row) = Temp_P((l-1)*NBf*NBc+m,row)+buf_of_value((j-1)*NBf*NBc+m)
                  END DO
                     

               else
                  !C insertion by column
                  Temp_P_row_size(row) = k+1
                  DO m = k,l,-1
                     Temp_PI(m+1,row) = Temp_PI(m,row)
                     Temp_P((m)*NBf*NBc+1:(m+1)*NBf*NBc,row) = &
                          & Temp_P((m-1)*NBf*NBc+1:m*NBf*NBc,row)
                  END DO
                  Temp_PI(l,row) = local_ag_no
                  DO m = 1, NBf*NBc
                     Temp_P((l-1)*NBf*NBc+m, row) = buf_of_value((j-1)*NBf*NBc+m)
                  END DO
                     

!!$                  Temp_P((l*9-8):(l*9),row) = buf_of_value((j*9-8):(j*9))
               end if
               !C-- end: insert node to Temp_P
            end if
            !C-- end:insert g_ag_no to hash_table
         END DO
      END DO
    end subroutine input_buf

    subroutine create_buf(dest,Neib_index,PE_num_index,NEIBPETOT, NEIBPE,   &
         &  STACK_IMPORT, NOD_IMPORT, STACK_EXPORT, NOD_EXPORT, PE_num_size,&
         &  PE_nums,nodes_for_each_PE,in_nodes_for_each_PE,Temp_P,Temp_PI,  &
         &  Temp_P_row_size,send_buf,send_buf_size,send_buf_dbl,            &
         &  send_buf_size_dbl,my_rank,GIN_rank,SOLVER_COMM,                 &
         &  pack_index,pack_index_dbl,own_aggre_size,LG_vector, NBf, NBc)

      implicit none
!!$      include  'mpif.h'
!!$      include  'precision.inc'

      INTEGER(kind=kint), INTENT(in) :: dest, Neib_index, PE_num_index, NEIBPETOT
      INTEGER(kind=kint), INTENT(in) :: my_rank,pack_index,pack_index_dbl,own_aggre_size
      INTEGER(kind=kint), INTENT(in) :: SOLVER_COMM
      INTEGER(kind=kint), INTENT(in) :: send_buf_size,send_buf_size_dbl, NBf, NBc
      INTEGER(kind=kint)             :: ierr

      integer(kind=kint ), INTENT(out):: send_buf(:)
      real   (kind=kreal), INTENT(out):: send_buf_dbl(:)

      INTEGER(kind=kint ), DIMENSION(:), intent(in) :: NEIBPE
      INTEGER(kind=kint ), DIMENSION(0:),intent(in) :: STACK_IMPORT,STACK_EXPORT
      INTEGER(kind=kint ), DIMENSION(:), intent(in) :: NOD_IMPORT,NOD_EXPORT
      INTEGER(kind=kint ), DIMENSION(:), intent(in) :: LG_vector

      INTEGER(kind=kint ), INTENT(in) :: PE_num_size
      INTEGER(kind=kint ), DIMENSION(:), INTENT(in) :: PE_nums
      INTEGER(kind=kint ), DIMENSION(:), INTENT(in) :: nodes_for_each_PE
      INTEGER(kind=kint ), DIMENSION(0:), INTENT(in) :: in_nodes_for_each_PE

      REAL   (kind=kreal), DIMENSION(:,:), intent(in) :: Temp_P
      INTEGER(kind=kint ), DIMENSION(:,:), intent(in) :: Temp_PI
      INTEGER(kind=kint ), DIMENSION(:),   intent(in) :: Temp_P_row_size

      INTEGER(kind=kint ), INTENT(in)    :: GIN_rank
      INTEGER(kind=kint )                :: position, position_dbl

      !C Neib_index != 0 
      position=0;position_dbl=0
      if(Neib_index > 0) then
         CALL pack_NOD(STACK_IMPORT,NOD_IMPORT,Temp_P_row_size,Temp_P,Temp_PI,    &
              &        SOLVER_COMM,GIN_rank,send_buf,send_buf_size,send_buf_dbl,  &
              &        send_buf_size_dbl,position,Neib_index,pack_index,          &
              &        position_dbl,pack_index_dbl,own_aggre_size,LG_vector, NBf, &
              &        NBc)

         CALL pack_NOD(STACK_EXPORT,NOD_EXPORT,Temp_P_row_size,Temp_P,Temp_PI,    &
              &        SOLVER_COMM,GIN_rank,send_buf,send_buf_size,send_buf_dbl,  &
              &        send_buf_size_dbl,position,Neib_index,pack_index,          &
              &        position_dbl,pack_index_dbl,own_aggre_size,LG_vector,NBf,NBc)
      end if
      if(PE_num_index > 0) then
         !C   PE_num_size,PE_nums,in_nodes_for_each_PE,nodes_for_each_PE
         CALL pack_NOD(in_nodes_for_each_PE,nodes_for_each_PE,Temp_P_row_size,Temp_P,  &
              &        Temp_PI,SOLVER_COMM,GIN_rank,send_buf,send_buf_size,            &
              &        send_buf_dbl,send_buf_size_dbl, position,PE_num_index,          &
              &        pack_index,position_dbl,pack_index_dbl,own_aggre_size,LG_vector,&
              &        NBf, NBc)
      end if
    end subroutine create_buf
    

    subroutine pack_NOD(STACK_PORT,NOD_PORT,Temp_P_row_size,Temp_P,Temp_PI,       &
         &              solver_comm,GIN_rank,send_buf,send_buf_size,send_buf_dbl, &
         &              send_buf_size_dbl,position,Neib_index,pack_index,         &
         &              position_dbl,pack_index_dbl,own_aggre_size,LG_vector,     &
         &              NBf,NBc)

      implicit none
!!$      include  'mpif.h'
!!$      include  'precision.inc'
      REAL   (kind=kreal), INTENT(in) :: Temp_P(:,:)
      INTEGER(kind=kint ), INTENT(in) :: Temp_PI(:,:)
      INTEGER(kind=kint ), INTENT(in) :: Temp_P_row_size(:)

      integer(kind=kint ), INTENT(in)    :: own_aggre_size
      INTEGER(kind=kint ), INTENT(in)    :: STACK_PORT(0:)
      INTEGER(kind=kint ), INTENT(in)    :: NOD_PORT(:)
      INTEGER(kind=kint ), INTENT(in)    :: LG_vector(:)

      INTEGER(kind=kint ), INTENT(in)    :: send_buf_size,send_buf_size_dbl,GIN_rank
      INTEGER(kind=kint ), INTENT(in)    :: Neib_index,pack_index,pack_index_dbl
      INTEGER(kind=kint ), INTENT(inout) :: position, position_dbl
      INTEGER(kind=kint ), INTENT(inout) :: send_buf(:)
      REAL   (kind=kreal), INTENT(inout) :: send_buf_dbl(:)
      INTEGER(kind=kint ), INTENT(in)    :: SOLVER_COMM, NBf,NBc

      INTEGER(kind=kint ) :: ierr,in_buf_size,tprsz,index_dbl
      INTEGER(kind=kint ) :: i,j,k,l,node_index_base,node,count,pack_size
      
      node_index_base = STACK_PORT(Neib_index-1)
      in_buf_size = STACK_PORT(Neib_index)-node_index_base

      position =position+1
      send_buf(pack_index+position)=in_buf_size

      position =position+1
      send_buf(pack_index+position)=0

      DO i=1,in_buf_size
         node = NOD_PORT(node_index_base+i)
         send_buf(pack_index+position+i) = send_buf(pack_index+position+i-1) + &
              &                            Temp_P_row_size(node)
      END DO
      position = position+in_buf_size


      count = 0
!!$      index_dbl =  pack_index_dbl+position_dbl
      DO i = 1, in_buf_size
         node  = NOD_PORT(node_index_base+i)
         TPrsz = Temp_P_row_size(node)
         DO j = 1, TPrsz
            index_dbl = pack_index_dbl+position_dbl+j
            
            DO k = 1, NBf*NBc
               send_buf_dbl((index_dbl-1)*NBf*NBc+k) = Temp_P((j-1)*NBf*NBc+k, node)
            END DO
            
            k = Temp_PI(j,node)
            if(k<=own_aggre_size) then
               send_buf(pack_index+position+j) = k + GIN_rank
            else 
               send_buf(pack_index+position+j) = LG_vector(k-own_aggre_size) 
#ifdef DEBUG
               if(LG_vector(k-own_aggre_size)==0) then
                  write(*,*) "unexpected error in LG_vector in pack_NOD()"
                  stop
               end if
#endif
            end if
         END DO
         position     = position     + tprsz
         position_dbl = position_dbl + tprsz
      END DO
    end subroutine pack_NOD

  end subroutine solver_SR_aggregates

end module comm_subs_NB

