#include "crs.h"

#include <iostream>
#include <new>

using std::bad_alloc;
using std::cout;
using std::endl;

crs::crs()
{
	n   = 0;
	nnz = 0;

	ptr = 0;
	col = 0;
	val = 0;

	new_done = false;
}


crs::~crs()
{
	if( crs_delete() ){
		cout << "exit in crs destructor." << endl;
	}
}


int crs::crs_new(int n, int nnz)
{
	this->n   = n;
	this->nnz = nnz;

	try{
		ptr = new int[n+1];
		col = new int[nnz];
		val = new double[nnz];
	}
	catch(bad_alloc)
	{
		cout << "crs bad alloc expection : " << n << " " << nnz << endl;
		return 1;
	}
	catch(...)
	{
		cout << "crs new expection." << endl;
		return 1;
	}
	new_done = true;
	return 0;
}


int crs::crs_delete()
{
	try{
		if(new_done){
			delete[] ptr;
			delete[] col;
			delete[] val;

			new_done = false;
		}

		n   = 0;
		nnz = 0;

		ptr = 0;
		col = 0;
		val = 0;
	}
	catch(...)
	{
		cout << "crs delete expection." << endl;
		return 1;
	}

	return 0;
}
