/** @file  cuda_amg.h
    @brief CUDAAMGˡ
    @author Kosuke Takahashi
 */

#ifndef __CUDA_AMG_H
#define __CUDA_AMG_H

#include "v_node.h"

/**
 * CUDAAMGˡΥ٥뤴ȤSetup
 * @param [in] vs          v_nodeν
 * @param [in] level       ػ
 * @param [in] solver_comm ѤMPIߥ˥
 */
void cuda_amg_setup(v_nodes *vs, int level, MPI_Comm solver_comm);


/**
 * V-cyclehostx,b٥ȥϿ
 * @param [in] vs v_nodeν
 * @param [in] x  hostx٥ȥ
 * @param [in] b  hostb٥ȥ
 */
void cuda_amg_cycle_setup(v_nodes *vs, double *x, double *b);

/**
 * «ȽդV-cycle.AMGˡñΤǤλѤ
 * @param [in]     vs         v_nodeν
 * @param [in,out] dx         in:devicex٥ȥ out:deviceβ٥ȥ
 * @param [in]     db         deviceb٥ȥ
 * @param [in,out] iter       in:ȿ¿ out:ȿ̿
 * @param [in]     ratio_test «Ƚؿݥ
 */
void cuda_amg_cycle(v_nodes *vs, double *dx, double *db, int *iter, bool (*ratio_test)(v_nodes&));

/**
 * «ȽʤV-cycle.ȤƤλѤ
 * @param [in]     vs         v_nodeν
 * @param [in,out] dx         in:devicex٥ȥ out:deviceβ٥ȥ
 * @param [in]     db         deviceb٥ȥ
 */
void cuda_amg_cycle(v_nodes *vs, double *dx, double *db);

/**
 * V-cycleλdevicex٥ȥhostx٥ȥ˥ԡ
 * @param [in]  vs v_nodeν
 * @param [out] x  hostx٥ȥ
 * @param [in]  b  hostb٥ȥ
 */
void cuda_amg_cycle_finalize(v_nodes *vs, double *x, double *b);


/**
 * CUDAAMGˡνλ
 * @param [in] vs v_nodeν
 */
void cuda_amg_finalize(v_nodes *vs);

#endif
