/** @file  cuda_bicgstab.h
    @brief CUDAAMG-BiCGSTABˡ
    @author Kosuke Takahashi
 */

#ifndef __CUDA_BICGSTAB_H
#define __CUDA_BICGSTAB_H

#include "v_node.h"


/**
 * CUDAAMG-BiCGSTABˡΥ٥뤴ȤSetup
 * @param [in] vs          v_nodeν
 * @param [in] level       ػ
 * @para, [in] solver_comm ѤMPIߥ˥
 */
void cuda_bicgstab_setup(v_nodes *vs, int level, MPI_Comm solver_comm);

/**
 * «ȽդV-cycle.AMGˡñΤǤλѤ
 * @param [in]     vs         v_nodeν
 * @param [in,out] x          in:x٥ȥ out:٥ȥ
 * @param [in]     b          b٥ȥ
 * @param [in,out] iter       in:ȿ¿ out:ȿ̿
 * @param [in]     ratio_test «Ƚؿݥ
 */
void cuda_bicgstab_cycle(v_nodes *vs, double *x, double *b, int *iter, bool (*ratio_test)(v_nodes&));

/**
 * CUDAAMG-BiCGSTABˡνλ
 * @param [in] vs v_nodeν
 */
void cuda_bicgstab_finalize(v_nodes *vs);

#endif
