#include "cuda_jacobi.h"

#include <cmath>
#include <cstring>
#include <iostream>
#include <new>

#include <curand.h>

using std::cout;
using std::endl;

namespace
{
	curandGenerator_t seed;
	bool flag = true;
}

int idr_jacobi_setup(lu_crs &src_mat, lu_icrs &dst_mat, int*b_n, int**b_cnt, int**b_ind, int **order)
{
	try{
		if( flag ){
		//	curandCreateGenerator(&seed, CURAND_RNG_PSEUDO_DEFAULT);
		//	curandCreateGenerator(&seed, CURAND_RNG_PSEUDO_XORWOW);
			curandCreateGenerator(&seed, CURAND_RNG_PSEUDO_MRG32K3A);
			curandSetPseudoRandomGeneratorSeed(seed, 1234ULL);
			flag = false;
		}

		*b_n   = 1;
		*b_cnt = new int[*b_n];
		*b_ind = new int[src_mat.n];

		*b_cnt[0] = src_mat.n;
		memset(*b_ind, 0, sizeof(int) * src_mat.n);

		if( convert_lu_crs_to_lu_icrs(src_mat, dst_mat, *b_n, *b_cnt, *b_ind, order) ){
			throw;
		}
	}
	catch(...){
		cout << "idr jacobi setup expection." << endl;
		return 1;
	}
	return 0;
}


void idr_jacobi_init(lu_icrs &a, double *x, double *b, double *r, double *p, double *gamma)
{
	int n;
	n = a[0].n;
	
	residual_error(a, x, b, r);

	curandGenerateUniformDouble(seed, p, 1);
	curandGenerateUniformDouble(seed, p, n);

	*gamma = 0.0;
}
