#include "cuda_jacobi.h"

#include <cmath>
#include <cstring>
#include <iostream>
#include <new>

#define INNER 0
#define OUTER 1

using std::bad_alloc;
using std::cout;
using std::endl;


int set_b_with_jacobi(lu_crs &mat, int b_cnt[], int b_ind[])
{
	int i, j;
	int n, start, end, col;

	b_cnt[INNER] = 0;
	b_cnt[OUTER] = 0;

	n  = mat.n;
	for(i=0; i<n; i++){

		start = mat.inl[ i ];
		end   = mat.inl[i+1];
		for(j=start; j<end; j++){
			col = mat.ial[j];
			if(col >= n){
				b_ind[i]=OUTER;
				b_cnt[OUTER]++;
				goto _next_node;
			}
		}

		start = mat.inu[ i ];
		end   = mat.inu[i+1];
		for(j=start; j<end; j++){
			col = mat.iau[j];
			if(col >= n){
				b_ind[i]=OUTER;
				b_cnt[OUTER]++;
				goto _next_node;
			}
		}
	
		b_ind[i]=INNER;
		b_cnt[INNER]++;

		_next_node:;
	}

	return 0;
}


int jacobi_setup(lu_crs &src_mat, lu_icrs &dst_mat, int*b_n, int**b_cnt, int**b_ind, int **order)
{
	try{
		//*b_n   = 2;
		//*b_cnt = new int[*b_n];
		//*b_ind = new int[src_mat.n];

		//set_b_with_jacobi(src_mat, *b_cnt, *b_ind);

		*b_n   = 1;
		*b_cnt = new int[*b_n];
		*b_ind = new int[src_mat.n];

		*b_cnt[0] = src_mat.n;
		memset(*b_ind, 0, sizeof(int) * src_mat.n);

		if( convert_lu_crs_to_lu_icrs(src_mat, dst_mat, *b_n, *b_cnt, *b_ind, order) ){
			throw;
		}
	}
	catch(...){
		cout << "jacobi setup expection." << endl;
		return 1;
	}
	return 0;
}
