#include "icrs.h"
#include "my_cuda.h"

#include <iostream>

using std::cout;
using std::endl;


icrs_part::icrs_part(const icrs_part &obj)
{
	n   = obj.n  ;
	np  = obj.np ;
	nnz = obj.nnz;
	row = obj.row;

	cnt = obj.cnt;
	col = obj.col;
	val = obj.val;

	new_done = false;
}

icrs_part::icrs_part()
{
	n   = 0;
	nnz = 0;
	row = 0;

	cnt = 0;
	col = 0;
	val = 0;

	new_done = false;
}

icrs_part::~icrs_part()
{
	if( icrs_part_delete() ){
		cout << "exit in crs destructor." << endl;
	}
}

int icrs_part::icrs_part_new(int n, int nnz)
{
	int check = 0;

	this->n   = n;
	this->nnz = nnz;

	try{
		check += my_cudaMalloc((void**)&cnt, sizeof(int)    * n  , "icrs part cnt");

		if(nnz != 0){
			check += my_cudaMalloc((void**)&col, sizeof(int)    * nnz, "icrs part col");
			check += my_cudaMalloc((void**)&val, sizeof(double) * nnz, "icrs part val");
		}else{
			col = 0;
			val = 0;
		}

		if(check != 0){
			throw;
		}
	}
	catch(...)
	{
		cout << "icrs_part new expection." << endl;
		return 1;
	}
	new_done = true;
	return 0;
}


int icrs_part::icrs_part_delete()
{
	int check = 0;

	try{
		if(new_done){
			check += my_cudaFree(cnt);
			check += my_cudaFree(col);
			check += my_cudaFree(val);

			if(check != 0){
				throw;
			}
			
			new_done = false;
		}


		n   = 0;
		nnz = 0;
		row = 0;

		cnt = 0;
		col = 0;
		val = 0;
	}
	catch(...)
	{
		cout << "icrs part delete expection." << endl;
		return 1;
	}
	return 0;
}
