#ifndef __ICRS_H
#define __ICRS_H

#include <vector>

using std::vector;

class icrs_part{
public:
	int n;
	int np;
	int nnz;
	int row;

	int *cnt;
	int *col;
	double *val;

	icrs_part(const icrs_part &obj);
	icrs_part();
	~icrs_part();

	int icrs_part_new(int n, int nnz);
	int icrs_part_delete();
private:
	bool new_done;
};
typedef std::vector<icrs_part> icrs;

void restriction(icrs &a, double *b, double *c);
void prolongation(icrs &a, double *b, double *c);

#endif
