#include "lu_icrs.h"
#include "my_cuda.h"

#include <iostream>

using std::cout;
using std::endl;

lu_icrs_part::lu_icrs_part(const lu_icrs_part &obj)
{
	n   = obj.n  ;
	np  = obj.np ;
	nnz = obj.nnz;
	row = obj.row;

	cnt = obj.cnt;
	col = obj.col;
	val = obj.val;
	d   = obj.d  ;

	new_done = false;
}

lu_icrs_part::lu_icrs_part()
{
	n   = 0;
	np  = 0;
	nnz = 0;
	row = 0;

	cnt = 0;
	col = 0;
	val = 0;
	d   = 0;

	new_done = false;
}

lu_icrs_part::~lu_icrs_part()
{
	if( lu_icrs_part_delete() ){
		cout << "exit in crs destructor." << endl;
	}
}

int lu_icrs_part::lu_icrs_part_new(int n, int nnz)
{
	int check = 0;

	this->n   = n;
	this->nnz = nnz;

	try{
		check += my_cudaMalloc((void**)&cnt, sizeof(int)    * n  , "lu_icrs part cnt");
		check += my_cudaMalloc((void**)&col, sizeof(int)    * nnz, "lu_icrs part col");
		check += my_cudaMalloc((void**)&val, sizeof(double) * nnz, "lu_icrs part val");
		check += my_cudaMalloc((void**)&d  , sizeof(double) * n  , "lu_icrs part val");

		if(check != 0){
			throw;
		}
	}
	catch(...)
	{
		cout << "lu_icrs_part new expection." << endl;
		return 1;
	}
	new_done = true;
	return 0;
}


int lu_icrs_part::lu_icrs_part_delete()
{
	int check = 0;

	try{
		if(new_done){
			check += my_cudaFree(cnt);
			check += my_cudaFree(col);
			check += my_cudaFree(val);
			check += my_cudaFree(d  );

			if(check != 0){
				throw;
			}

			new_done = false;
		}

		n   = 0;
		np  = 0;
		nnz = 0;
		row = 0;

		cnt = 0;
		col = 0;
		val = 0;
		d   = 0;
	}
	catch(...)
	{
		cout << "lu_icrs part delete expection." << endl;
		return 1;
	}
	return 0;
}
