#ifndef __LU_ICRS_H
#define __LU_ICRS_H

#include <vector>

using std::vector;

class lu_icrs_part{
public:
	int n;
	int np;
	int nnz;
	int row;

	int *cnt;
	int *col;
	double *val;
	double *d;

	lu_icrs_part(const lu_icrs_part &obj);
	lu_icrs_part();
	~lu_icrs_part();

	int lu_icrs_part_new(int n, int nnz);
	int lu_icrs_part_delete();
private:
	bool new_done;
};
typedef std::vector<lu_icrs_part> lu_icrs;


double get_two_norm_residual(lu_icrs &a, double *b, double *c);
void mmult(lu_icrs &a, double *x, double *b);
void residual_error(lu_icrs &a, double *x, double *b, double *e);

#endif
