module matrix_type_mod
  use data_structure_for_amg, only: COMMUNICATION_TABLE
  include 'precision.inc'


  type matrix
     integer(kind=kint) :: N,NP,NPL,NPU,NB
     integer(kind=kint), pointer :: INU(:),INL(:)
     integer(kind=kint), pointer :: IAU(:),IAL(:)
     real  (kind=kreal), pointer :: AU(:),AL(:),D(:)

     type(communication_table) :: comm_table
     
     integer(kind=kint) :: dim
     real(kind=kreal), pointer :: WS(:)
     real(kind=kreal), pointer :: WR(:)

     integer(kind=kint) :: SOLVER_COMM, my_rank
    
  end type matrix
  
  contains
    
  subroutine set_mat_data(mat, N, NP, NPL, NPU, D, AL, INL, IAL, &
       & AU, INU, IAU, comm_tbl, WS, WR, dim, SOLVER_COMM, my_rank)
    
    implicit none    

    type(matrix) :: mat
    integer(kind=kint), intent(in) :: N,NP,NPL,NPU
    real(kind=kreal),   intent(in), target :: D(:),AL(:),AU(:)
    integer(kind=kint), intent(in), target :: INL(0:),INU(0:)
    integer(kind=kint), intent(in), target :: IAL(:),IAU(:)

    type(communication_table) :: comm_tbl

    integer(kind=kint) :: dim
    real(kind=kreal), intent(in), target :: WS(:)
    real(kind=kreal), intent(in), target :: WR(:)

    integer(kind=kint) :: SOLVER_COMM, my_rank

    mat % N = N;  mat % NP = NP; mat % NPL = NPL; mat % NPU = NPU
    mat % D => D; mat % AL => AL; mat % AU => AU    
    mat % INL => INL; mat % INU => INU
    mat % IAL => IAL; mat % IAU => IAU


    mat % comm_table = comm_tbl
    
    mat % dim = dim
    mat % WS => WS
    mat % WR => WR
    
    mat % SOLVER_COMM = SOLVER_COMM
    mat % my_rank = my_rank
    
  end subroutine set_mat_data

    

end module matrix_type_mod
