/** @file  my_mpi_cuda.h
    @brief MPICUDA碌̿ͥ뷲
    @author Kosuke Takahashi
 */
#ifndef __MY_MPI_CUDA_H
#define __MY_MPI_CUDA_H

#include "boader_zone.h"
#include "lab_matrix.h"
#include "my_cuda.h"

#include <cuda_runtime.h>
#include <iostream>
#include <mpi.h>

/**
 * @enum  comm_margin_opp
 * @brief ̿α黻Ҥꤹ
 */
typedef enum
{
	COMM_MARGIN_EQL, /**<  */
	COMM_MARGIN_ADD  /**< û */
} comm_margin_opp;

template<comm_margin_opp opp> void comm_margin(double data[], boader_zone *import_table, boader_zone *export_table);
void icomm_margin(double data[], boader_zone *import_table, boader_zone *export_table, comm_margin_opp opp);
void icomm_margin_wait(double data[], boader_zone *import_table, boader_zone *export_table, comm_margin_opp opp);

bool my_cuda_vector_less_with_mpi(double *dx, double *dy, int n, MPI_Comm solver_comm);
double my_cuda_dot_with_mpi(double *a, double *b, int n, MPI_Comm solver_comm);
double get_two_norm_residual_with_mpi(lu_crs &a, double *x, double *b, MPI_Comm solver_comm);
double get_two_norm_residual_with_mpi(lu_icrs &a, double *x, double *b, MPI_Comm solver_comm);

#endif
