MODULE output_data
CONTAINS

  subroutine aggregate_transfer(my_rank, in_aggregates_result_size,             &
       & in_aggregates_result, aggregates_result, NPROCS, GIN_aggregate,        &
       & aggregate_table_array, aggregate_number_in_table, PE_list,             &
       & PE_list_size, new_GIN_aggregate)
    USE int_vec_module, &
         & only: int_vec, int_vec_initialize, check_and_extend, deallocate_int_vec
    
    implicit none
    include 'precision.inc'

    integer(kind=kint)            :: my_rank, NPROCS

    !C ----
    integer(kind=kint)    :: GIN_aggregate(0:)

    integer(kind=kint)            :: PE_list_size
    integer(kind=kint), pointer   :: PE_list(:, :)

    integer(kind=kint)            :: in_aggregates_result_size
    integer(kind=kint), pointer   :: in_aggregates_result(:)
    integer(kind=kint), pointer   ::    aggregates_result(:)

    integer(kind=kint), pointer   :: aggregate_number_in_table(:)
    type(int_vec), pointer   :: aggregate_table_array(:)
    !C ----

    !C ----
    integer(kind=kint)    :: new_GIN_aggregate(0:)

    integer(kind=kint)            :: new_PE_list_size
    integer(kind=kint), pointer   :: new_PE_list(:)

    integer(kind=kint)            :: new_in_aggregates_result_size
    integer(kind=kint), pointer   :: new_in_aggregates_result(:)
    integer(kind=kint), pointer   :: new_aggregates_result(:)

    integer(kind=kint), pointer   :: new_aggregate_number_in_table(:)
    type(int_vec), pointer   :: new_aggregate_table_array(:)
    !C ----

    call aggregate_transfer_(my_rank, in_aggregates_result_size,         &
         & in_aggregates_result, aggregates_result, NPROCS,              &
         & GIN_aggregate, aggregate_table_array,                         &
         & aggregate_number_in_table, PE_list(:,1), PE_list_size,        &
         & new_in_aggregates_result_size, new_in_aggregates_result,      &
         & new_aggregates_result, new_GIN_aggregate,                     &
         & new_aggregate_table_array, new_aggregate_number_in_table,     &
         & new_PE_list, new_PE_list_size )



    call copy_aggre_data(my_rank, NPROCS, &
         !C------ original
       & GIN_aggregate,                   &
       & PE_list_size,                    &
       & PE_list,                         &
       & in_aggregates_result_size,       &
       & in_aggregates_result,            &
       & aggregates_result,               &
       & aggregate_number_in_table,       &
       & aggregate_table_array,           &
       !C------ transferred aggre info
       & new_GIN_aggregate,               &
       & new_PE_list_size,                &
       & new_PE_list,                     &
       & new_in_aggregates_result_size,   &
       & new_in_aggregates_result,        &
       & new_aggregates_result,           &
       & new_aggregate_number_in_table,   &
       & new_aggregate_table_array)  
    


  end subroutine aggregate_transfer

    

  !C transfer according to new_GIN_aggregate
  subroutine aggregate_transfer_(my_rank, in_aggregates_result_size, in_aggregates_result, &
       & aggregates_result, NPROCS, GIN_aggregate, aggregate_table_array,                  &
       & aggregate_number_in_table, PE_list, PE_list_size,                                 &
       & new_in_aggregates_result_size, new_in_aggregates_result, new_aggregates_result,   &
       & new_GIN_aggregate, new_aggregate_table_array, new_aggregate_number_in_table,      &
       & new_PE_list, new_PE_list_size )
    USE int_vec_module, &
         & only: int_vec, int_vec_initialize, check_and_extend, deallocate_int_vec


    implicit none
    include 'precision.inc'

    integer(kind=kint)            :: my_rank, NPROCS

    !C ----
    integer(kind=kint)   :: GIN_aggregate(0:)

    integer(kind=kint)            :: PE_list_size
    integer(kind=kint)            :: PE_list(:)

    integer(kind=kint)            :: in_aggregates_result_size
    integer(kind=kint), pointer   :: in_aggregates_result(:)
    integer(kind=kint), pointer   ::    aggregates_result(:)

    integer(kind=kint), pointer   :: aggregate_number_in_table(:)
    type(int_vec), pointer   :: aggregate_table_array(:)
    
    !C ----

    !C ----
    integer(kind=kint)   :: new_GIN_aggregate(0:)

    integer(kind=kint)            :: new_PE_list_size
    integer(kind=kint), pointer   :: new_PE_list(:)

    integer(kind=kint)            :: new_in_aggregates_result_size
    integer(kind=kint), pointer   :: new_in_aggregates_result(:)
    integer(kind=kint), pointer   :: new_aggregates_result(:)
    
    integer(kind=kint), pointer   :: new_aggregate_number_in_table(:)
    type(int_vec), pointer   :: new_aggregate_table_array(:)

    !C size of aggregate table is limited by MAX_SIZE
    integer(kind=kint) :: MAX_SIZE = 100000
    !C ----

    !C ----
    integer(kind=kint)            :: lower_gl, new_lower_gl, common_lower_gl
    integer(kind=kint)            :: upper_gl, new_upper_gl, common_upper_gl

    integer(kind=kint)            :: gather_PE

    integer(kind=kint)            :: i, j, k, l, m, n

    integer(kind=kint)            :: js, je, njs, nje

    integer(kind=kint)            :: local_aggregates_size, new_local_aggregates_size
    integer(kind=kint)            :: neiPE_gatPE_fl, one_only_fl, neiPE_gatPE_gl, final_val
    integer(kind=kint), pointer   :: local_to_global_array(:)
    !C----

    !C write(*,*) my_rank, ":", "aggregate transferring ", "from ", source,"PE to ", dest, "PE"

    !C new_lower_gl = new_GIN_aggregate(my_rank)+1
    !C new_upper_gl = new_GIN_aggregate(my_rank+1)
    !C lower_gl = GIN_aggregate(my_rank)+1
    !C upper_gl = GIN_aggregate(my_rank+1)
    !C 
    !C if(lower_gl < new_lower_gl) common_lower_gl = new_lower_gl
    !C if(lower_gl > new_lower_gl) common_lower_gl = lower_gl
    !C if(upper_gl < new_upper_gl) common_upper_gl = upper_gl
    !C if(upper_gl > new_upper_gl) common_upper_gl = new_upper_gl
    !C 
    !C 1. insert new_lower_gl to common_lower_gl to local aggregates in in_aggregate_index.
    !C     !C if there is corresponding entry in  aggregate table, 
    !C     !C   then change aggregate table and transfer corresponding external aggregate to local aggregate.
    !C 2. shift common local aggregate number by (lower_gl - new_lower_gl), and insert aggregates.
    !C 3. insert common_upper_gl to new_upper_gl to local aggregates in in_aggregate_index.
    !C     !C if there is corresponding entry in  aggregate table, 
    !C     !C   then change aggregate table and transfer corresponding external aggregate to local aggregate.
    !C 4. lower_gl ... common_lower_gl transfer as external aggregate
    !C     !C shift local aggregate number to the end of the aggregate data, and store in aggregate_table
    !C 5. common_upper_gl ... upper_gl transfer as external aggregate
    !C     !C shift local aggregate number to the end of the aggregate data, and store in aggregate_table
    !C 6. modified original external aggregates are shifted by (lower_gl - new_lower_gl + new upper - upper_gl) 
    !C     !C in both aggregate data and aggregate table.

    !C ----- about lower_gl, upper_gl, ...
      lower_gl     = GIN_aggregate(my_rank)+1
      upper_gl     = GIN_aggregate(my_rank+1)
      new_lower_gl = new_GIN_aggregate(my_rank)+1
      new_upper_gl = new_GIN_aggregate(my_rank+1)

      if(lower_gl <  new_lower_gl) common_lower_gl = new_lower_gl
      if(lower_gl >  new_lower_gl) common_lower_gl = lower_gl
      if(lower_gl == new_lower_gl) common_lower_gl = lower_gl
      if(upper_gl <  new_upper_gl) common_upper_gl = upper_gl
      if(upper_gl >  new_upper_gl) common_upper_gl = new_upper_gl
      if(upper_gl == new_upper_gl) common_upper_gl = upper_gl
    !C -----

    !C ----- about local_aggre_size, new_local_aggregates_size
      !C ꥲȿ
      !C local_aggregates_size, new_local_aggregates_size:PEAGο
          local_aggregates_size =     GIN_aggregate(my_rank+1)-    GIN_aggregate(my_rank)
      new_local_aggregates_size = new_GIN_aggregate(my_rank+1)-new_GIN_aggregate(my_rank)
    !C -----

    !C -----
      

      !C ٤ƤAGôPE_rankꤹ
      !C gather_PE:٤ƤAGôPE
      !C----- modified-----
      do i = 1, NPROCS
         if(new_GIN_aggregate(i)-new_GIN_aggregate(i-1)>0) exit
      end do
      gather_PE =  i-1
      !C write(*,*) "gather_pe", gather_PE, my_rank
      !C----- modified-----      

!!$      if(new_local_aggregates_size /= 0) then
!!$        gather_PE = my_rank
!!$      end if
    !C -----

!C ##################################################################
!C  ƤAG1ĤPEô
!C ##################################################################
!C   example 
!C  lower_gl         upper_gl
!C  1                2
!C  |----------------|
!C
!C  new_lower_gl                                new_upper_gl
!C  1                                           7
!C  |-------------------------------------------|
!C
!C  common_lower_gl  common_upper_gl
!C  1                2
!C  |----------------|
!C ##################################################################

    !C ƤAG򣱤ĤPEô
!C    if((new_lower_gl <= new_upper_gl) .and. (common_lower_gl <= common_upper_gl) .and. &  !C 11/05
!C     & (common_lower_gl == new_lower_gl) .and. (common_upper_gl < new_upper_gl)) then     !C 11/05
    if((new_lower_gl <= new_upper_gl)) then

    !C ----- about new_in_aggregates_result_size, new_in_aggregates_result(:), new_aggregates_result(:)
      !C (new_in_aggregates_result_size)
      new_in_aggregates_result_size = new_GIN_aggregate(my_rank+1) - new_GIN_aggregate(my_rank)

      !C ΰ(new_in_aggregates_result(:))
      allocate(new_in_aggregates_result(0:new_in_aggregates_result_size))

      !C ΰ(new_aggregates_result(:))
      i = in_aggregates_result(in_aggregates_result_size)
      allocate(new_aggregates_result(i))

      !C (in_aggregates_result(:))
      !C ָAGʬѤʤΤǡʬΤ߽
      do i = 1, local_aggregates_size
        js  = in_aggregates_result(i-1)+1
        je  = in_aggregates_result(i)
        new_aggregates_result(js:je) = aggregates_result(js:je)
      end do
    !C -----

    !C ----- about new_PE_list_size and new_PE_list(:)
      !C (new_PE_list_size(:))
      !C ϡ0 PEϤΤޤޤˤƤ
      new_PE_list_size = PE_list_size

      !C ΰ(new_PE_list(:))
      allocate(new_PE_list(1:NPROCS))

      !C (new_PE_list(:))
      new_PE_list(1:new_PE_list_size) = PE_list(1:PE_list_size)
    !C -----

    !C ----- about new_aggregate_number_in_table, new_aggregate_table_array
      !C ΰ(new_aggregate_number_in_table(:))
      allocate(new_aggregate_number_in_table(1:NPROCS))

      !C (new_aggregate_number_in_table(:))
      new_aggregate_number_in_table(1:new_PE_list_size) = aggregate_number_in_table(1:PE_list_size)

      !C ΰ(new_aggregate_table_array(:,:))
      allocate(new_aggregate_table_array(NPROCS))
      do i = 1, NPROCS
         call int_vec_initialize(new_aggregate_table_array(i))
      end do


      !C (new_aggregate_table_array(:,:))
      do i = 1, PE_list_size
        j = new_aggregate_number_in_table(i)
        k = aggregate_number_in_table(i)
        call check_and_extend(new_aggregate_table_array(i), 2*j)
        new_aggregate_table_array(i) % int_array(1:2*j) = &
             aggregate_table_array(i) % int_array(1:2*k)
     end do
    !C -----

    !C ----- about new_in_aggregates_result(:)
      !C Ĵ(new_in_aggregates_result(:))
      do i = 0, new_in_aggregates_result_size
        new_in_aggregates_result(i) = 0
      end do

      do i = 1, local_aggregates_size
        l = in_aggregates_result(i) - in_aggregates_result(i-1)
        new_in_aggregates_result(i) = l
      end do

      do i = 1, PE_list_size                                          
        j = aggregate_number_in_table(i)                      
!DEC$ NOUNROLL
        do k = 1, j*2, 2
          !C l:̤οǤΥǥåѤơǿƤ 
          !C l:AGγǿ
           l = in_aggregates_result(aggregate_table_array(i) % int_array(k+1)) - &
                & in_aggregates_result(aggregate_table_array(i) % int_array(k+1)-1)
           if(l>=1) then
             new_in_aggregates_result(aggregate_table_array(i) % int_array(k)) = l
          end if
        end do   
      end do

      do i = 1, new_in_aggregates_result_size
        new_in_aggregates_result(i) =  new_in_aggregates_result(i) + new_in_aggregates_result(i-1)
      end do
    !C -----

    !C ----- about new_aggregates_result(:)
      do i = 1, PE_list_size
      j = aggregate_number_in_table(i)
        do k = 1, j*2, 2
          l   = aggregate_table_array(i) % int_array(k)
          m   = aggregate_table_array(i) % int_array(k+1)
          js  = in_aggregates_result(m-1)+1
          je  = in_aggregates_result(m)
          njs = new_in_aggregates_result(l-1)+1
          nje = new_in_aggregates_result(l)
          new_aggregates_result(njs:nje) = aggregates_result(js:je)
        end do
      end do
    !C -----

    !C ----- about new_aggregate_number_in_table(:)
      !C Ĵ(new_aggregate_number_in_table(:))
      !C gather_PEϡAGʤΤǳAGơ֥(new_aggregate_number_in_table(:))ͤ0Ȥ롣
      new_aggregate_number_in_table(1:new_PE_list_size) = 0
    !C -----

    end if

!C ##################################################################
!C  1ĤôAGʤPEˤĤƤν
!C ##################################################################
!C   example 
!C  lower_gl         upper_gl
!C  3                4
!C  |----------------|
!C
!C  new_lower_gl     new_upper_gl
!C  8                7                                            
!C  (ô)AGʤ
!C
!C  common_lower_gl  common_upper_gl
!C  8                4
!C  ʬʤ
!C ##################################################################

    !C (ô)AG1ĤʤPEν
    if(new_lower_gl > new_upper_gl) then

    !C ----- about new_in_aggregates_result_size, new_in_aggregates_result(:), new_aggregates_result(:)
      !C gather_PEǤϤʤPEǤϡPEAGưϤʤ
      !C (new_in_aggregates_result_size)
      new_in_aggregates_result_size = in_aggregates_result_size
    
      !C ΰ(new_in_aggregates_result(:))
      allocate(new_in_aggregates_result(0:new_in_aggregates_result_size))

      !C (new_in_aggregates_result(:))
      do i = 0, in_aggregates_result_size
        new_in_aggregates_result(i) = in_aggregates_result(i)
      end do

      !C ΰ(new_aggregates_result(:))
      i = new_in_aggregates_result(new_in_aggregates_result_size)
      allocate(new_aggregates_result(i))

      !C AG̤οǤѹʤΤǡΤޤϿԤ
      do i = 1, in_aggregates_result_size
        js  = in_aggregates_result(i-1)+1
        je  = in_aggregates_result(i)
        new_aggregates_result(js:je) = aggregates_result(js:je)
      end do
    !C -----

    !C ----- about new_PE_list_size, new_PE_list(:)
      !C (new_PE_list_size)
      new_PE_list_size = PE_list_size

      do i = 1, PE_list_size
        if(PE_list(i) .eq. gather_PE) exit
      end do
      if(i > PE_list_size) then
        if(in_aggregates_result_size .ne. 0) new_PE_list_size = PE_list_size + 1  !C 11/05ѹ
      else
        new_PE_list_size = PE_list_size
      end if

      !C ΰ(new_PE_list)
      allocate(new_PE_list(1:NPROCS))

      !C (new_PE_list)
      new_PE_list(1:new_PE_list_size) = 0
      new_PE_list(1:PE_list_size) = PE_list(1:PE_list_size)
    !C ----- 

    !C ----- about new_aggregate_number_in_table(:)
      !C ΰ(new_aggregate_number_in_table(:))
      allocate(new_aggregate_number_in_table(1:NPROCS))

      !C (new_aggregate_number_in_table(:))  !C βɬפʡ
      new_aggregate_number_in_table(1:new_PE_list_size) = 0
      new_aggregate_number_in_table(1:PE_list_size) = aggregate_number_in_table(1:PE_list_size)

      l = 0  !C l:PEAGι
      do i = 1, new_PE_list_size
         if(new_PE_list(i) .ne. gather_PE) l = l + new_aggregate_number_in_table(i)
      end do

      do i = 1, new_PE_list_size 
        if((new_PE_list_size .eq. 1) .and. (new_PE_list(i) .eq. gather_PE)) then 
          new_aggregate_number_in_table(i) = new_aggregate_number_in_table(i) + local_aggregates_size
        else
           if(new_PE_list(i) .eq. gather_PE) then
             new_aggregate_number_in_table(i) = new_aggregate_number_in_table(i) + l + local_aggregates_size
           else if(new_PE_list(i) .ne. gather_PE) then
             new_aggregate_number_in_table(i) = 0
           end if
        end if
      end do
    !C -----

    !C ----- new_aggregate_table_array(:,:)
      !C ΰ(new_aggregate_table_array(:,:))
      allocate(new_aggregate_table_array(NPROCS))
      do i = 1, NPROCS
         call int_vec_initialize(new_aggregate_table_array(i))
      end do

!C      new_aggregate_table_array(1:MAX_SIZE*2,NPROCS) = 0

      !C (new_aggregate_table_array(:,:))
      !C neiPE_gatPE_gl : PEǤgather_PEôƤAG
      !C PEgather_PEǤϤʤϡneiPE_gatPE_gl = 0 Ȥʤ
      neiPE_gatPE_gl = 0
      do i = 1, PE_list_size
        j = aggregate_number_in_table(i)
        if(new_PE_list(i) == gather_PE) then      
           call check_and_extend(new_aggregate_table_array(i), j*2)
           new_aggregate_table_array(i) % int_array(1:j*2)= &
                & aggregate_table_array(i) % int_array(1:j*2)
           neiPE_gatPE_gl = aggregate_number_in_table(i)
        end if
      end do

      !C neiPE_gatPE_fl : PEgather_PE뤫ɤ
      !C neiPE_gatPE_fl = 0 : PEgather_PE
      !C neiPE_gatPE_fl = 1 : PEgather_PEʤ
      do i = 1, PE_list_size
        if(PE_list(i) .eq. gather_PE .and. aggregate_number_in_table(i) .eq. 0) exit
      end do
      if(i > PE_list_size) then
        neiPE_gatPE_fl = 0
      else
        neiPE_gatPE_fl = 1
      end if

      one_only_fl = 0
      k = 0
      do i = 1, PE_list_size
         do j = 1, new_PE_list_size
            l =     aggregate_number_in_table(i)
            m = new_aggregate_number_in_table(j)
            if(PE_list(i) .ne. gather_PE .and. new_PE_list(j) .eq. gather_PE .and. l .gt. 0) then
               if(PE_list_size .ne. new_PE_list_size) then               
                  call check_and_extend(new_aggregate_table_array(j), l*2+k)
                  new_aggregate_table_array(j) % int_array(k+1:l*2+k) = &
                       & aggregate_table_array(i) % int_array(1:l*2)
                  k = l*2+k
               else
                  if(neiPE_gatPE_fl .eq. 1) then
                     call check_and_extend(new_aggregate_table_array(j), l*2+k)
                     new_aggregate_table_array(j) % int_array(k+1:l*2+k)= &
                          & aggregate_table_array(i) % int_array(1:l*2)
                     k = l*2+k
                  else if(neiPE_gatPE_fl .eq. 0) then
                     !C one_only_fl:ǽΰ٤k νԤflag
                     if(one_only_fl .eq. 0) then 
                        k = neiPE_gatPE_gl*2
                        one_only_fl = 1
                     end if
                     call check_and_extend(new_aggregate_table_array(j), l*2+k)
                     new_aggregate_table_array(j) % int_array(k+1:l*2+k)= &
                          & aggregate_table_array(i) % int_array(1:l*2)
                     k = l*2+k
                  end if
               end if
            end if
         end do
      end do

      !C AGäΤAGȤʤäˡơ֥(new_aggregate_table_array(:))˾񤭹
      if(local_aggregates_size .gt. 0 .and. new_local_aggregates_size .eq. 0) then  !C .gt. --> ">"

        !C ΰ(local_to_global_array(:))
        !C local_to_global_array:AGäΤ,AGˤʤäȤ˥ơ֥˾Ǽ뤿
        allocate(local_to_global_array(1:local_aggregates_size*2))
        local_to_global_array(1:local_aggregates_size*2) = 0

        !C Хֹ
        l = GIN_aggregate(my_rank)
        do i = 1, local_aggregates_size*2, 2
          l = l + 1
          local_to_global_array(i) = l
        end do

        !C ֹ
        k = 1
        do i = 2, local_aggregates_size*2, 2
          local_to_global_array(i) = k
          k = k + 1
        end do
      end if

      final_val=0
      do i = 1, new_PE_list_size
        j = new_aggregate_number_in_table(i)
        if(new_PE_list(i) .eq. gather_PE) then
           call check_and_extend(new_aggregate_table_array(i), j*2)
           new_aggregate_table_array(i) % &
                & int_array((j-local_aggregates_size)*2+1: j*2)= &
                & local_to_global_array(1:local_aggregates_size*2)
           final_val = j*2 
        end if
      end do

      !C 顼(󥵥ξ¤ۤ顢ץཪλ)
      if(new_PE_list_size > 0) then
         if(final_val > MAX_SIZE*2) then
            print *, "####################    ABEND   ####################"
            print *, "####################  Err info  ####################"
            print *, "subroutine : aggregate_transfer"
            print *, "my_rank    : ", my_rank
            print *, "final_val(=", final_val, ") > MAX_SIZE*2(=", MAX_SIZE*2, ")"
            print *, "####################################################"
            stop  !C program end
         end if
      end if

    end if  !C ----- if(new_lower_gl > new_upper_gl) then

    !C -----

    !C ----- aggregate_check
!C    call aggregate_check(in_aggregates_result_size, in_aggregates_result, &
!C         & new_in_aggregates_result_size, new_in_aggregates_result)
    !C -----

!C #define PRINT_DATA
#ifdef PRINT_DATA

    if(my_rank == 0) then

      write(*,*) "############################################"

      write(*,*) "my_rank:", my_rank

      write(*,*) "############################################"

      write(*,*) "lower_gl:", lower_gl, "upper_gl:", upper_gl
      write(*,*) "new_lower_gl:", new_lower_gl, "new_upper_gl:", new_upper_gl
      write(*,*) "common_lower_gl:", common_lower_gl, "common_upper_gl:", common_upper_gl

      write(*,*) "############################################"

      write(*,*) "GIN_aggre:", GIN_aggregate(:)

      write(*,*) "in_aggregates_result_size:", my_rank, ":", in_aggregates_result_size
      write(*,*) "in_aggregates_result:", my_rank, ":", in_aggregates_result(0:in_aggregates_result_size)

      do i = 1, in_aggregates_result_size
        js = in_aggregates_result(i-1) +1
        je = in_aggregates_result(i)        
        write(*,*) "local aggre no:",i,":",aggregates_result(js:je)
      end do

      write(*,*) "PE_list_size:", PE_list_size
      write(*,*) "PE_list(:):", PE_list(1:PE_list_size)
     
      do i = 1, PE_list_size
        j = aggregate_number_in_table(i)
        write(*,*) "aggregate_number_in_table:", i, ":", aggregate_number_in_table(i)
        write(*,*) "aggregate table for PE_list(",i,"):", aggregate_table_array( i) % int_array(1:j*2)   
      end do

      write(*,*) "############################################"

      write(*,*) "new_GIN_aggre:", new_GIN_aggregate(:)

      write(*,*) "new_in_aggregates_result_size:", my_rank, ":", new_in_aggregates_result_size
      write(*,*) "new_in_aggregates_result:", my_rank, ":", new_in_aggregates_result(0:new_in_aggregates_result_size)

      do i = 1, new_in_aggregates_result_size
        js = new_in_aggregates_result(i-1) +1
        je = new_in_aggregates_result(i)        
        write(*,*) "new local aggre no:",i,":",new_aggregates_result(js:je)
      end do

      write(*,*) "new_PE_list_size:", new_PE_list_size
      write(*,*) "new_PE_list(:):", new_PE_list(1:new_PE_list_size)
     
      do i = 1, new_PE_list_size
        j = new_aggregate_number_in_table(i)
        write(*,*) "new_aggregate_number_in_table:", i, ":", new_aggregate_number_in_table(i)
        write(*,*) "new_aggregate table for PE_list(",i,"):", new_aggregate_table_array(i) % int_array(1:j*2)  
      end do

      write(*,*) "############################################"

    end if

#endif
    
  contains
    subroutine aggregate_check(in_aggregates_result_size, in_aggregates_result, &
         & new_in_aggregates_result_size, new_in_aggregates_result)

      implicit none
      include 'precision.inc'

      integer(kind=kint)          :: in_aggregates_result_size
      integer(kind=kint), pointer :: in_aggregates_result(:)

      integer(kind=kint)          :: new_in_aggregates_result_size
      integer(kind=kint), pointer :: new_in_aggregates_result(:)

      integer(kind=kint)          :: i, j, k, l, m, n
      integer(kind=kint)          :: js, je

      integer(kind=kint), pointer :: aggre_ele(:), aggre_list(:)

      !C ǥåƤ뤫Υå
      do i = 1, new_in_aggregates_result_size
         if(new_in_aggregates_result(i) < new_in_aggregates_result(i-1)) then
            print *, "####################    ABEND   ####################"
            print *, "####################  Err info  ####################"
            print *, "subroutine : aggregate_check"
            print *, "my_rank    : ", my_rank
            print *, "new_in_aggregates_result(:) is not slowly increase"
            print *, "####################################################"
            stop
         end if
      end do

      !C ̤οǤκ
      l = in_aggregates_result(in_aggregates_result_size)
      m = new_in_aggregates_result(new_in_aggregates_result_size)

      !C ̤οǿΥå
      if(l .ne. m) then
         print *, "####################    ABEND   ####################"
         print *, "####################  Err info  ####################"
         print *, "subroutine : aggregate_check"
         print *, "my_rank    : ", my_rank
         print *, "anteroposterior element number is different"
         print *, "####################################################"
         stop
      end if

      !C ----- ָ̤οǤ롼פȤAGʬƤ뤫å
      !C ΰ(aggre_ele(:)) ----- ̤οǤ°Ƥ륢ꥲȤǼ
      allocate(aggre_ele(1:new_in_aggregates_result(new_in_aggregates_result_size)))
      aggre_ele(1:new_in_aggregates_result(new_in_aggregates_result_size)) = 0

      !C ΰ(aggre_list()) ----- ָΥꥲȤ̤οǤޤޤƤ뤫Υꥹ
      !C ( 0):ꥲȤ̤οǤ0
      !C (-1):ꥲȤ̤οǤ1İʾ
      allocate(aggre_list(1:new_in_aggregates_result_size))
      aggre_list(1:new_in_aggregates_result_size) = 0

      !C ̤οǤ°Ƥ륢ꥲȤå
      do i = 1, new_in_aggregates_result(new_in_aggregates_result_size)
         do j = 1 , new_in_aggregates_result_size
            if(aggre_ele(i) .eq. 0 .and. i <= new_in_aggregates_result(j)) aggre_ele(i) = j
         end do
      end do

      do i = 1, new_in_aggregates_result_size
         js = new_in_aggregates_result(i-1)+1
         je = new_in_aggregates_result(i)

         !C ̤οǤΥ롼פѹƤʤå
         do j = js, je-1
            if(aggre_ele(j) .ne. aggre_ele(j+1)) then
               print *, "####################    ABEND   ####################"
               print *, "####################  Err info  ####################"
               print *, "subroutine : aggregate_check"
               print *, "my_rank    : ", my_rank
               print *, "aggregate of belonging element are different"
               print *, "####################################################"
               stop
            end if
         end do

         !C ָΥꥲȤ1󤷤ѤƤʤΤ
         if(js<=je) then
            if(aggre_list(aggre_ele(js)) .eq. -1) then
               print *, "####################    ABEND   ####################"
               print *, "####################  Err info  ####################"
               print *, "subroutine : aggregate_check"
               print *, "my_rank    : ", my_rank
               print *, "new aggregate was refered twice"
               print *, "####################################################"
               stop
            else if(aggre_list(aggre_ele(js)) .eq. 0 .and. js<=je) then
               aggre_list(aggre_ele(js)) = -1
            end if
         end if

      end do

      !C -----

    end subroutine aggregate_check

  end subroutine aggregate_transfer_

  
  !C this sub is assumed to be called in aggregate_transfer().
  !C new_* arrays except for new_GIN_aggregate are deallocated in this sub.
  subroutine copy_aggre_data(&
       & my_rank, NPROCS,                 &
       !C------ original
       & GIN_aggregate,                   &
       & PE_list_size,                    &
       & PE_list,                         &
       & in_aggregates_result_size,       &
       & in_aggregates_result,            &
       & aggregates_result,               &
       & aggregate_number_in_table,       &
       & aggregate_table_array,           &
       !C------ transferred aggre info
       & new_GIN_aggregate,               &
       & new_PE_list_size,                &
       & new_PE_list,                     &
       & new_in_aggregates_result_size,   &
       & new_in_aggregates_result,        &
       & new_aggregates_result,           &
       & new_aggregate_number_in_table,   &
       & new_aggregate_table_array)  
    USE int_vec_module, &
         & only: int_vec, int_vec_initialize, check_and_extend, deallocate_int_vec
    
    implicit none
    include 'precision.inc'

    integer(kind=kint), intent(in) :: my_rank, NPROCS
    
    !C ----
    integer(kind=kint) :: GIN_aggregate(0:)

    integer(kind=kint)          :: PE_list_size
    integer(kind=kint), pointer :: PE_list(:,:)

    integer(kind=kint)          :: in_aggregates_result_size
    integer(kind=kint), pointer :: in_aggregates_result(:)
    integer(kind=kint), pointer ::    aggregates_result(:)

    integer(kind=kint), pointer :: aggregate_number_in_table(:)
    type(int_vec), pointer :: aggregate_table_array(:)
    !C ----

    !C ----
    integer(kind=kint) :: new_GIN_aggregate(0:)
    integer(kind=kint)          :: new_PE_list_size
    integer(kind=kint), pointer :: new_PE_list(:)

    integer(kind=kint)          :: new_in_aggregates_result_size
    integer(kind=kint), pointer :: new_in_aggregates_result(:)
    integer(kind=kint), pointer :: new_aggregates_result(:)

    integer(kind=kint), pointer :: new_aggregate_number_in_table(:)
    type(int_vec), pointer :: new_aggregate_table_array(:)
    !C ----
    
    integer(kind=kint) :: i
    
    !C copy new_GIN_aggregate(:)
    GIN_aggregate(:) = new_GIN_aggregate(:)

    
    !C copy PE_list and PE_list_size
    DO i = PE_list_size+1, new_PE_list_size
       PE_list(i,1) = new_PE_list(i)
    end DO
    DO i = PE_list_size+1, new_PE_list_size
       PE_list(i,2) = 0
       PE_list(i,3) = 0
    END DO
    

    PE_list_size = new_PE_list_size
    deallocate(new_PE_list)
    
    !C copy aggregate info
    in_aggregates_result_size = new_in_aggregates_result_size
    deallocate(in_aggregates_result, aggregates_result)
    in_aggregates_result => new_in_aggregates_result
    aggregates_result    => new_aggregates_result
    
    !C copy aggregate table
    DO i = 1, NPROCS
       call deallocate_int_vec(aggregate_table_array(i))
    END DO
    deallocate(aggregate_table_array)
    deallocate(aggregate_number_in_table)
    
    aggregate_number_in_table => new_aggregate_number_in_table
    aggregate_table_array     => new_aggregate_table_array
    
  end subroutine copy_aggre_data

  subroutine output_aggre_data(my_rank, in_aggregates_result_size,                 &
       & in_aggregates_result, aggregates_result, NPROCS, GIN_aggregate,           &
       & aggregate_table_array, aggregate_number_in_table, PE_list, PE_list_size)
    USE int_vec_module, &
         & only: int_vec, int_vec_initialize, check_and_extend, deallocate_int_vec
    
    IMPLICIT none
    include 'precision.inc'
    
    integer(kind=kint),intent(in) :: my_rank, in_aggregates_result_size, NPROCS
    integer(kind=kint),intent(in) :: in_aggregates_result(0:), aggregates_result(:)
    integer(kind=kint),intent(in) :: GIN_aggregate(0:)
    type(int_vec), pointer :: aggregate_table_array(:)
    integer(kind=kint),intent(in) :: aggregate_number_in_table(:)
    integer(kind=kint),intent(in) :: PE_list(:,:), PE_list_size
    
    integer(kind=kint) :: i, j, k


    character fname*20
    
    write(fname, '("aggre_", i3.3)') my_rank
    
    fname = trim(fname)
    write(*,*) fname
    
    open(15, file=fname, form='formatted', status = 'replace')

    write(15,*) GIN_aggregate(0:NPROCS)
    write(15,*) PE_list_size 
    write(15,*) PE_list(1:PE_list_size,1) 
    write(15,*) in_aggregates_result_size
    write(15,*) in_aggregates_result(0:in_aggregates_result_size)
    k = in_aggregates_result(in_aggregates_result_size)
    write(15,*) aggregates_result (1:k)

    write(15,*) aggregate_number_in_table(1:PE_list_size)    
    do i = 1, PE_list_size
       j = aggregate_number_in_table(i)
       write(15, *) aggregate_table_array(i) % int_array(1:2*j)
    end do
    
    close(15)
    
  END SUBROUTINE output_aggre_data

!C this subroutine only output scalar problem matrix
  SUBROUTINE output_mat_data(my_rank, B_i, output_path)
    USE data_structure_for_AMG
    USE problem_matrix, only: LEVEL_NUM, REORDERED_FL, nds_index_aft_dst, &
         & order_for_dst, SOLVER_COMM, nds_index
    USE matrix_dist_mtom, only: distribute_vector
    !$    USE omp_lib

    IMPLICIT NONE
    include 'mpif.h'
!!$      INTEGER(kind=kint), INTENT(in)    :: LEVEL_NUM

    INTEGER(kind=kint)                :: N,NP,NPL,NPU,NB


    !C DIMENSION(NP)
    REAL   (kind=kreal), DIMENSION(:), pointer:: D

    REAL   (kind=kreal), DIMENSION(:) ::  B_i
    !C DIMENSION(NP)
    
    character(*), intent(in) :: output_path
    
    REAL   (kind=kreal), DIMENSION(:), pointer::  X
    !C DIMENSION(NP)

    REAL   (kind=kreal), DIMENSION(:), pointer::  AU
    REAL   (kind=kreal), DIMENSION(:), pointer::  AL

    INTEGER(kind=kint), DIMENSION(:), pointer ::  INU
    !C DIMENSION(0:N)
    INTEGER(kind=kint), DIMENSION(:), pointer ::  IAU
    !C DIMENSION(NPU)
    INTEGER(kind=kint), DIMENSION(:), pointer ::  INL
    !C DIMENSION(0:N)
    INTEGER(kind=kint), DIMENSION(:), pointer ::  IAL

    INTEGER(kind=kint), intent(in) :: my_rank

    INTEGER(kind=kint ) :: nth_lev,is,ie,k, i

    real(kind=kreal), allocatable :: B(:)
    

    type(INTER_LEVEL_OPERATOR), pointer :: R, P

    INTEGER(kind=kint) :: NEIBPETOT, iNEIBPETOT
    INTEGER(kind=kint), pointer :: NEIBPE(:)
    INTEGER(kind=kint), pointer :: STACK_IMPORT(:),STACK_EXPORT(:)
    INTEGER(kind=kint), pointer :: NOD_IMPORT(:),NOD_EXPORT(:)

    character(len= 4 ) :: penum,penum_left
    character(len=20 ) :: fname
    integer(kind=kint) :: dev_num,NPSI,NPSE, N_i, turn, steps, ierr
    
    logical :: mat_format=.false.
    logical :: all_levels=.false.


    dev_num = my_rank + 20
!!$    write(penum,'(i4   )') my_rank
!!$    penum_left = adjustl(penum)
!!$    if(all_levels) then
!!$       write(fname,'(a11,a4)') 'matdat.', penum_left
!!$    else
!!$       write(fname,'(a15,a4)') 'single_lev.', penum_left
!!$    end if
    if(mat_format)then
       open(dev_num, file= output_path, status= 'unknown', form= 'formatted')
    else
       open(dev_num, file= output_path, status= 'unknown', form= 'unformatted')
    end if



    N  = HIERARCHICAL_DATA(1) % N
    NP = HIERARCHICAL_DATA(1) % NP
    NPL= HIERARCHICAL_DATA(1) % NPL
    NPU= HIERARCHICAL_DATA(1) % NPU
    INU=>HIERARCHICAL_DATA(1) % INU
    INL=>HIERARCHICAL_DATA(1) % INL
    IAU=>HIERARCHICAL_DATA(1) % IAU


    allocate(B(NP))

    if(REORDERED_FL) then
       !C distribute vector B
       N_i = nds_index(my_rank+1) - nds_index(my_rank)
       call distribute_vector(nds_index_aft_dst, order_for_dst, SOLVER_COMM, B_i, N_i, B, 1)
    else
       !C copy B_i
       DO i =1, NP
          B(i) = B_i(i)
       END DO
    end if

    steps = 32
    do turn = 0, steps-1
       call MPI_Barrier(SOLVER_COMM, ierr)
       if(turn /= mod(my_rank,steps)) cycle

       NEIBPETOT    =  HIERARCHICAL_DATA(1) % COMM_TABLE % NEIBPETOT
       STACK_IMPORT => HIERARCHICAL_DATA(1) % COMM_TABLE % STACK_IMPORT
       STACK_EXPORT => HIERARCHICAL_DATA(1) % COMM_TABLE % STACK_EXPORT
       NOD_IMPORT   => HIERARCHICAL_DATA(1) % COMM_TABLE % NOD_IMPORT
       NOD_EXPORT   => HIERARCHICAL_DATA(1) % COMM_TABLE % NOD_EXPORT
       NEIBPE       => HIERARCHICAL_DATA(1) % COMM_TABLE % NEIBPE

       D => HIERARCHICAL_DATA(1) % D
       IAL=>HIERARCHICAL_DATA(1) % IAL
       AU =>HIERARCHICAL_DATA(1) % AU
       AL =>HIERARCHICAL_DATA(1) % AL
       !C-----------MAT-DATA------------C!

#ifdef PRINT_REZ
       write(*,*)  output_path,":",  N, "rows ", NP, "cols ", NEIBPETOT, "neighboring PEs"
#endif

       NB = 1
       if(mat_format) then
          if(all_levels) then
             write(dev_num,'(10i10)') LEVEL_NUM
          end if

          if(all_levels) then
             write(dev_num,'(10i10)') N, NP, NPL, NPU, NEIBPETOT
             write(dev_num,'(10i10)') (INL(k),k=1,N)
             write(dev_num,'(10i10)') (INU(k),k=1,N)
          else
             !C NB is inserted in order to match the input matrix
             write(dev_num,'(10i10)') N, NP, NPL, NPU, NB, NEIBPETOT
             write(dev_num,'(10i10)') (INL(k),k=1,NP)
             write(dev_num,'(10i10)') (INU(k),k=1,NP)
          end if

          write(dev_num,'(10i10)') (IAL(k),k=1,NPL)
          write(dev_num,'(10i10)') (IAU(k),k=1,NPU)

          write(dev_num,'(5e29.20e3)') (AL(k),k=1,NPL)

          write(dev_num,'(5e29.20e3)') (AU(k),k=1,NPU)

          if(all_levels) then
             write(dev_num,'(5e29.20e3)') (D(k),k=1,N)
             write(dev_num,'(5e29.20e3)') (B(k),k=1,N)
          else
             !C the range is changed in order to match the input matrix
             write(dev_num,'(5e29.20e3)') (D(k),k=1,NP)
             write(dev_num,'(5e29.20e3)') (B(k),k=1,NP)
          end if
          !C-----------COMM-DATA----------C!
          write(dev_num,'(10i10)') (NEIBPE(k),k=1,NEIBPETOT)
          write(dev_num,'(10i10)') (STACK_IMPORT(k),k=1,NEIBPETOT)
          write(dev_num,'(10i10)') (STACK_EXPORT(k),k=1,NEIBPETOT)
          NPSI=STACK_IMPORT(NEIBPETOT)
          NPSE=STACK_EXPORT(NEIBPETOT)
          write(dev_num,'(10i10)') (NOD_IMPORT(k),k=1,NPSI)
          write(dev_num,'(10i10)') (NOD_EXPORT(k),k=1,NPSE)
       else
          if(all_levels) then
             write(dev_num) LEVEL_NUM
          end if

          if(all_levels) then
             write(dev_num) N, NP, NPL, NPU, NEIBPETOT
             write(dev_num) (INL(k),k=1,N)
             write(dev_num) (INU(k),k=1,N)

          else
             !C NB is inserted in order to match the matIN format
             write(dev_num) N, NP, NPL, NPU, NB, NEIBPETOT          
             write(dev_num) (INL(k),k=1,NP)
             write(dev_num) (INU(k),k=1,NP)

          end if
          write(dev_num) (IAL(k),k=1,NPL)
          write(dev_num) (IAU(k),k=1,NPU)

          write(dev_num) (AL(k),k=1,NPL)
          write(dev_num) (AU(k),k=1,NPU)
          
          

          if(all_levels) then
             write(dev_num) (D(k),k=1,N)
             write(dev_num) (B(k),k=1,N)
          else
             !C the range is changed in order to match the input matrix
             write(dev_num) (D(k),k=1,NP)
             write(dev_num) (B(k),k=1,NP)
          end if


          !C-----------COMM-DATA----------C!
          write(dev_num) (NEIBPE(k),k=1,NEIBPETOT)
          write(dev_num) (STACK_IMPORT(k),k=1,NEIBPETOT)
          write(dev_num) (STACK_EXPORT(k),k=1,NEIBPETOT)
          NPSI=STACK_IMPORT(NEIBPETOT)
          NPSE=STACK_EXPORT(NEIBPETOT)
          write(dev_num) (NOD_IMPORT(k),k=1,NPSI)
          write(dev_num) (NOD_EXPORT(k),k=1,NPSE)

       end if


       if(all_levels) then
          DO nth_lev = 2,LEVEL_NUM

             N  = HIERARCHICAL_DATA(nth_lev) % N
             NP = HIERARCHICAL_DATA(nth_lev) % NP
             NPL= HIERARCHICAL_DATA(nth_lev) % NPL
             NPU= HIERARCHICAL_DATA(nth_lev) % NPU
             INU=>HIERARCHICAL_DATA(nth_lev) % INU
             INL=>HIERARCHICAL_DATA(nth_lev) % INL
             IAU=>HIERARCHICAL_DATA(nth_lev) % IAU

             NEIBPETOT    =  HIERARCHICAL_DATA(nth_lev) % COMM_TABLE % NEIBPETOT
             STACK_IMPORT => HIERARCHICAL_DATA(nth_lev) % COMM_TABLE % STACK_IMPORT
             STACK_EXPORT => HIERARCHICAL_DATA(nth_lev) % COMM_TABLE % STACK_EXPORT
             NOD_IMPORT   => HIERARCHICAL_DATA(nth_lev) % COMM_TABLE % NOD_IMPORT
             NOD_EXPORT   => HIERARCHICAL_DATA(nth_lev) % COMM_TABLE % NOD_EXPORT
             NEIBPE       => HIERARCHICAL_DATA(nth_lev) % COMM_TABLE % NEIBPE

             D => HIERARCHICAL_DATA(nth_lev) % D
             IAL=>HIERARCHICAL_DATA(nth_lev) % IAL
             AU =>HIERARCHICAL_DATA(nth_lev) % AU
             AL =>HIERARCHICAL_DATA(nth_lev) % AL

             if(mat_format) then
                !C--------------MAT-DATA--------------C!
                write(dev_num,'(10i10)') N, NP, NPL, NPU, NEIBPETOT
                write(dev_num,'(10i10)') (INL(k),k=1,N)
                write(dev_num,'(10i10)') (INU(k),k=1,N)
                write(dev_num,'(10i10)') (IAL(k),k=1,NPL)
                write(dev_num,'(10i10)') (IAU(k),k=1,NPU)

                write(dev_num,'(5e29.20e3)') (AL(k),k=1,NPL)
                write(dev_num,'(5e29.20e3)') (AU(k),k=1,NPU)
                write(dev_num,'(5e29.20e3)') (D(k),k=1,N)

                !C--------------COMM-DATA-------------C!
                write(dev_num,'(10i10)') (NEIBPE(k),k=1,NEIBPETOT)
                write(dev_num,'(10i10)') (STACK_IMPORT(k),k=1,NEIBPETOT)
                write(dev_num,'(10i10)') (STACK_EXPORT(k),k=1,NEIBPETOT)
                NPSI=STACK_IMPORT(NEIBPETOT)
                NPSE=STACK_EXPORT(NEIBPETOT)
                write(dev_num,'(10i10)') (NOD_IMPORT(k),k=1,NPSI)
                write(dev_num,'(10i10)') (NOD_EXPORT(k),k=1,NPSE)

                !C--------------INTER_LEVEL_OPERATOR_COMM_TABLE----------C!
                iNEIBPETOT = HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NEIBPETOT
                write(dev_num,'(10i10)') iNEIBPETOT
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NEIBPE(k),k=1,iNEIBPETOT)
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_IMPORT(k),k=1,iNEIBPETOT)
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_EXPORT(k),k=1,iNEIBPETOT)
                NPSI = HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_IMPORT(iNEIBPETOT)
                NPSE = HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_EXPORT(iNEIBPETOT)
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NOD_IMPORT(k),k=1,NPSI)
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NOD_EXPORT(k),k=1,NPSE)

                !C--------------R/P------------------C!
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % R % IN(k),K=1,NP)
                ie = HIERARCHICAL_DATA(nth_lev) % R % IN(NP)
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % R % CN(k),k=1,ie)
                write(dev_num,'(5e29.20e3)') (HIERARCHICAL_DATA(nth_lev) % R % V(k),k=1,ie)

                N  = HIERARCHICAL_DATA(nth_lev-1) % N
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % P % IN(k),k=1,N)
                ie = HIERARCHICAL_DATA(nth_lev) % P % IN(N)
                write(dev_num,'(10i10)') (HIERARCHICAL_DATA(nth_lev) % P % CN(k),k=1,ie)
                write(dev_num,'(5e29.20e3)') (HIERARCHICAL_DATA(nth_lev) % P % V(k),k=1,ie)
             else
                !C--------------MAT-DATA--------------C!
                write(dev_num) N, NP, NPL, NPU, NEIBPETOT
                write(dev_num) (INL(k),k=1,N)
                write(dev_num) (INU(k),k=1,N)
                write(dev_num) (IAL(k),k=1,NPL)
                write(dev_num) (IAU(k),k=1,NPU)

                write(dev_num) (AL(k),k=1,NPL)
                write(dev_num) (AU(k),k=1,NPU)
                write(dev_num) (D(k),k=1,N)

                !C--------------COMM-DATA-------------C!
                write(dev_num) (NEIBPE(k),k=1,NEIBPETOT)
                write(dev_num) (STACK_IMPORT(k),k=1,NEIBPETOT)
                write(dev_num) (STACK_EXPORT(k),k=1,NEIBPETOT)
                NPSI=STACK_IMPORT(NEIBPETOT)
                NPSE=STACK_EXPORT(NEIBPETOT)
                write(dev_num) (NOD_IMPORT(k),k=1,NPSI)
                write(dev_num) (NOD_EXPORT(k),k=1,NPSE)

                !C--------------INTER_LEVEL_OPERATOR_COMM_TABLE----------C!
                iNEIBPETOT = HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NEIBPETOT
                write(dev_num) iNEIBPETOT
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NEIBPE(k),k=1,iNEIBPETOT)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_IMPORT(k),k=1,iNEIBPETOT)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_EXPORT(k),k=1,iNEIBPETOT)
                NPSI = HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_IMPORT(iNEIBPETOT)
                NPSE = HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % STACK_EXPORT(iNEIBPETOT)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NOD_IMPORT(k),k=1,NPSI)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % INT_LVL_TABLE % NOD_EXPORT(k),k=1,NPSE)

                !C--------------R/P------------------C!
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % R % IN(k),K=1,NP)
                ie = HIERARCHICAL_DATA(nth_lev) % R % IN(NP)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % R % CN(k),k=1,ie)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % R % V(k),k=1,ie)

                N  = HIERARCHICAL_DATA(nth_lev-1) % N
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % P % IN(k),k=1,N)
                ie = HIERARCHICAL_DATA(nth_lev) % P % IN(N)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % P % CN(k),k=1,ie)
                write(dev_num) (HIERARCHICAL_DATA(nth_lev) % P % V(k),k=1,ie)

             end if

          END DO
       end if
    end do
    close(dev_num)
    
    deallocate(B)
    
  end subroutine output_mat_data
end module output_data
