!C   Copyright (C) 2010 High Performance Computing Laboratory, Kogakuin University.
!C   All rights reserved.
!C
!C   Redistribution and use in source and binary forms, with or without
!C   modification, are permitted provided that the following conditions are met:
!C   1. Redistributions of source code must retain the above copyright
!C      notice, this list of conditions and the following disclaimer.
!C   2. Redistributions in binary form must reproduce the above copyright
!C      notice, this list of conditions and the following disclaimer in the
!C      documentation and/or other materials provided with the distribution.
!C   3. Neither the name of the project nor the names of its contributors
!C      may be used to endorse or promote products derived from this software
!C      without specific prior written permission.
!C
!C   THIS SOFTWARE IS PROVIDED BY THE SCALABLE SOFTWARE INFRASTRUCTURE PROJECT
!C   ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
!C   TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
!C   PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE SCALABLE SOFTWARE INFRASTRUCTURE
!C   PROJECT BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
!C   OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
!C   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
!C   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
!C   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
!C   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
!C   POSSIBILITY OF SUCH DAMAGE.

MODULE redist_mat_mod
  implicit none
  include 'precision.inc'

  integer(kind=kint ), allocatable :: com_send_buf(:)  
  integer(kind=kint ), allocatable :: in_recv_buf(:), pes(:)
  integer(kind=kint) :: n_pes, recv_buf_size
  integer(kind=kint ), allocatable :: chk_rows_mv_LtoU(:)
  integer(kind=kint ), allocatable, target :: recvbuf(:)
  REAL   (kind=kreal), allocatable, target :: recvbuf_dbl(:)
  integer(kind=kint ), allocatable :: recv_buf_sz(:)
  integer(kind=kint ) :: nd_range_l, nd_range_u

  integer(kind=kint) :: buf_NPL, buf_NPU, num_of_ex_nds_in_L
  
  !C-- Split matrix data format except for D and B..
  type split_mat
     integer(kind=kint ) :: row_sz, npl, npu
     integer(kind=kint ), pointer :: INL_s(:), INU_s(:), row_num_s(:)
     integer(kind=kint ), pointer :: IAL_s(:), IAU_s(:)
     real   (kind=kreal), pointer :: AU_s(:), AL_s(:)
  end type split_mat
  type(split_mat), allocatable :: split_mats(:)


  integer(kind=kint ), allocatable :: index(:), index2(:), index_nodes(:)
  
END MODULE  redist_mat_mod
