/** @file  smoother.h
    @brief smoothercuda_amgѤ˥åԥ󥰤
    @author Kosuke Takahashi
 */
#ifndef __SMOOTHER_H
#define __SMOOTHER_H

#include "cuda_gauss_seidel.h"
#include "cuda_jacobi.h"
#include "cuda_idr_jacobi.h"
#include "lu_decomposition.h"
#include "v_node.h"

/**
 * @enum  SMOOTHER_TYPE
 * @brief ࡼꤹ
 */
enum SMOOTHER_TYPE
{
	MCGS, /**< Multi Color Gauss-Seidel method */
	JC,   /**< Jacobi method */
	IDR,  /**< IDR Jacobi method */
	LU,   /**< LU Decomposition method */
	SMOOTHER_LENGTH
};

void multi_color_gauss_seidel_setup(v_node &v);
void multi_color_gauss_seidel(v_node &v, double omega);

void jacobi_setup(v_node &v);
void jacobi(v_node &v, double omega);
void jacobi_finalize(v_node &v);

void idr_jacobi_setup(v_node &v);
void idr_jacobi_init(v_node &v);
void idr_jacobi(v_node &v, double omega);
void idr_jacobi_finalize(v_node &v);

void lu_decomposition_setup(v_node &v);
void lu_decomposition(v_node &v, double omega);
void lu_decomposition_finalize(v_node &v);

#endif
