/** @file  v_node.h
    @brief V-cycleγƳؤΥΡɤ򥯥饹
    @author Kosuke Takahashi
 */

#ifndef __V_NODE_H
#define __V_NODE_H

#include "boader_zone.h"
#include "lab_matrix.h"

#include <vector>

using std::vector;



/** 
 * @class v_node
 * @brief V-cycleΥΡ
 */  
class v_node
{
public:
	int level;  /**< ֹ */

	int n;      /**< ̿ʬޤޤʤX,B٥ȥĹ */
	int np;     /**< ̿ʬޤX,B٥ȥĹ */

	lu_crs a;   /**< A */
	crs r;      /**< Restriction */
	crs p;      /**< Prolongation */

	double *x;  /**< X٥ȥ */
	double *b;  /**< B٥ȥ */

	int dn;     /**< ̿ʬޤޤʤdeviceX,B٥ȥĹ */
	int dnp;    /**< ̿ʬޤdeviceX,B٥ȥĹ */

	lu_icrs da; /**< deviceιA */
	icrs dr;    /**< deviceRestriction */
	icrs dp;    /**< deviceProlongation */

	double *dx; /**< deviceX٥ȥ */
	double *db; /**< deviceB٥ȥ */
	double *de; /**< deviceλĺ٥ȥ */

	int b_n;       /**< icrs,lu_icrsʬο */
	int *b_cnt;    /**< icrs,lu_icrsʬγƹԿ */
	int *b_ind;    /**< AιԤȤʬֹ */
	int *order; /**< 󥰥ǡ */

	int iter;      /**< SmootherŬѲ */
	double omega;  /**< Sommtherδ· */

	double *scl_vec;   /** scaling vector on CPU **/
	double *d_scl_vec; /** scaling vector on GPU **/


	boader_zone area_inner;      /**< ʬˤĤƤ̿ơ֥ */
	boader_zone area_outer;      /**< ʬγˤĤƤ̿ơ֥ */
	boader_zone aggregate_inner; /**< ꥲȤˤĤƤ̿ơ֥ */
	boader_zone aggregate_outer; /**< ꥲȤˤĤƤ̿ơ֥ */

	MPI_Comm comm; /**< MPIߥ˥ */

	void (*smoother_setup)(v_node&);          /**< smootherΥåȥå״ؿݥ */
	void (*smoother_kernel_init)(v_node&);    /**< smootherΥͥνؿݥ */
	void (*smoother_kernel)(v_node&, double); /**< smootherΥͥؿݥ */
	void (*smoother_finalize)(v_node&);       /**< smootherνλؿݥ */

	v_node();
	~v_node();

	/**
	 * v_nodeν
	 * @param [in] n      ̿Ǥޤޤʤǿ
	 * @param [in] np     ̿Ǥޤǿ
	 * @retval 0 
	 * @retval 1 ۾
	 */
	int v_node_new(int n, int np);

	/**
	 * v_nodeβ
	 * @retval 0 
	 * @retval 1 ۾
	 */
	int v_node_delete();

	/**
	 * ؿݥ󥿤Ͽ줿smoother
	 * @retval 0 
	 * @retval 1 ۾
	 */
	int smoother(int iter, double omega);
};

typedef vector<v_node> v_nodes;

#endif
